-- Projektarbeit von Christian Walpen
------------------------------------------------
-- **************
-- Personalplaner
-- **************

use master
go

--if exists (select 1 from sys.databases where name = 'Personalplaner')
--begin
--   drop database Personalplaner
--   print 'Datenbank gelscht'
--end


-- Erstellt Datenbank Personalplaner und macht die dazugehrigen Tabellen
if not exists (select 1 from sys.databases where name = 'Personalplaner')
begin
	create database Personalplaner
	--go
	alter database Personalplaner set recovery simple
	--go
	alter database Personalplaner set auto_close off
	--go
	print 'Datenbank erstellt'
end 
go

use Personalplaner
go


----------------------------------------------------------------------------------------------
-- Falls Tabellen vorhanden sind mssen diese gelscht werden
----------------------------------------------------------------------------------------------
if exists (select 1 from sysobjects where name = 'DienstSchema'and type = 'U') begin drop table DienstSchema end
if exists (select 1 from sysobjects where name = 'Colorplan'and type = 'U') begin drop table Colorplan end
if exists (select 1 from sysobjects where name = 'Arbeitspensum'and type = 'U') begin drop table Arbeitspensum end
if exists (select 1 from sysobjects where name = 'Arbeitszeit'and type = 'U') begin drop table Arbeitszeit end
if exists (select 1 from sysobjects where name = 'PersonalAbteilung'and type = 'U') begin drop table PersonalAbteilung end
if exists (select 1 from sysobjects where name = 'Ferien'and type = 'U') begin drop table Ferien end
if exists (select 1 from sysobjects where name = 'DienstZeit'and type = 'U') begin drop table DienstZeit end
if exists (select 1 from sysobjects where name = 'Dienstplan'and type = 'U') begin drop table Dienstplan end
if exists (select 1 from sysobjects where name = 'PrsVerwaltung'and type = 'U') begin drop table PrsVerwaltung end
if exists (select 1 from sysobjects where name = 'PersonAnstellung'and type = 'U') begin drop table PersonAnstellung end
if exists (select 1 from sysobjects where name = 'PersonZeiten'and type = 'U') begin drop table PersonZeiten end
if exists (select 1 from sysobjects where name = 'Options'and type = 'U') begin drop table Options end
if exists (select 1 from sysobjects where name = 'Terminplan'and type = 'U') begin drop table Terminplan end
if exists (select 1 from sysobjects where name = 'DienstSerie'and type = 'U') begin drop table DienstSerie end
if exists (select 1 from sysobjects where name = 'Saldoanpassung'and type = 'U') begin drop table Saldoanpassung end
if exists (select 1 from sysobjects where name = 'PlanSchema'and type = 'U') begin drop table PlanSchema end
if exists (select 1 from sysobjects where name = 'ArbeitsPlanzprs'and type = 'U') begin drop table ArbeitsPlanzprs end
if exists (select 1 from sysobjects where name = 'Dienstplanzprs'and type = 'U') begin drop table Dienstplanzprs end

--if exists (select 1 from sysobjects where name = 'ZusatzPerson'and type = 'U') begin drop table ZusatzPerson end
if exists (select 1 from sysobjects where name = 'Termin'and type = 'U') begin drop table Termin end
if exists (select 1 from sysobjects where name = 'Anstellung'and type = 'U') begin drop table Anstellung end
if exists (select 1 from sysobjects where name = 'Person'and type = 'U') begin drop table Person end
if exists (select 1 from sysobjects where name = 'ArbeitsPlan'and type = 'U') begin drop table ArbeitsPlan end
if exists (select 1 from sysobjects where name = 'Schemas'and type = 'U') begin drop table Schemas end
if exists (select 1 from sysobjects where name = 'Abteilung'and type = 'U') begin drop table Abteilung end
if exists (select 1 from sysobjects where name = 'Dienst'and type = 'U') begin drop table Dienst end
if exists (select 1 from sysobjects where name = 'ArbeitsTage'and type = 'U') begin drop table ArbeitsTage end
if exists (select 1 from sysobjects where name = 'Beschreibung'and type = 'U') begin drop table Beschreibung end
if exists (select 1 from sysobjects where name = 'PlanungsJahr'and type = 'U') begin drop table PlanungsJahr end
if exists (select 1 from sysobjects where name = 'userrights' and type='U') begin drop table userrights end
if exists (select 1 from sysobjects where name = 'mandant' and type='U') begin drop table mandant end
----------------------------------------------------------------------------------------------
-- Alle Tabellen erstellen
----------------------------------------------------------------------------------------------

create table Dienstplan(
   PlanID          int not null,
   PrsID           int not null,
   Datum           datetime not null,
   AbteilungID     int not null,
   DienstID        int not null,
--constraint PK_DienstPlanID primary key (PrsID, Datum, PlanID, AbteilungID)
)

create table Colorplan(
   PlanID          int not null,
   PrsID           int not null,
   Datum           datetime not null,
   AbteilungID     int not null,
   Colorname       varchar(32) not null,
   ARGB            int not null,
--constraint PK_DienstPlanID primary key (PrsID, Datum, PlanID, AbteilungID)
)

create table Person(
   PrsId           int identity(1,1) not null,
   Vorname         Varchar(32) not null,
   Nachname        Varchar(32) not null,
   Strasse         varchar(32) not null,
   Strassennr      varchar(5)  null,
   Postfach        varchar(10) null,
   PLZ             char(5)     not null,
   Ort             varchar(32) not null,
   TelnrP          varchar(15) null,
   TelnrN          varchar(15) null,
   Email           varchar(60) null,
   PersonTyp       int not null,
   mandid          char(2) not null
--constraint PK_PrsID primary key (PrsID)
)

create table Arbeitspensum(
--   PensumID        int identity(1,1) not null,
   PrsID           int      not null,
   Von             datetime not null,
   Bis             datetime not null,
   Prozent         smallint not null,
   Status          tinyint  not null,
--constraint PK_Pensum primary key (PrsID, Von)
)

create table Arbeitszeit(
   PrsID           int           not null,
   PlanID          int           not null,
   AbteilungID     int           not null,
   Soll            decimal(5,2)  not null,
   Haben           decimal(5,2)  not null,
   Ferien          decimal(5,2)  not null,
--constraint PK_StundenID primary key (PrsID, PlanID)
)

create table PersonZeiten(
   PrsID           int           not null,
   FerienSaldo     decimal(5,2)  not null,
   ArbeitszeitSaldo decimal(5,2)  not null,
   JahrID           int           not null
--constraint PK_PersonZeit primary key (PrsID)
)

create table Anstellung(
  AnstellungID     int identity(1,1) not null,
  Name             varchar(32)       not null,
  Prioritaet       smallint          not null, -- Damit eine Priorisierung statfinden kann
  BeschrID         int               null,
  EinsatzProTag    int               not null,
  Gerechnet        int               not null, --1: gerechnet   2: nicht gerechnet
  mandid           char(2)           not null
-- constraint PK_AnstellungID primary key (AnstellungID)
)

create table PersonAnstellung
(
  PrsID            int not null,
  AnstellungID     int not null,
  Von              datetime not null,
  Bis              datetime not null
--constraint PK_PersonAnstellung primary key (PrsID, AnstellungID)
)

create table ArbeitsPlan(
   PlanID         int not null identity(1,1),
   ATID           int not null,
   Name           varchar(32) null,
   JahrID         int not null,
   SchemaID       int not null,
   --AbteilungID    int not null,
   Von            datetime not null,
   Bis            datetime not null, 
   Status         int not null,
   mandid         char(2) not null
--constraint PK_ArbeitsPlan primary key (PlanID)
)

create table Abteilung(
  AbteilungID      int identity(1,1) not null,
  Name             varchar(32)       not null,
  BeschrID         int               null,
  stundenprotag    decimal(5,2)      not null,
  mandid           char(2)           not null
--  Gerechnet        int               not null
--constraint PK_AbteilungID primary key (AbteilungID)
)

create table PersonalAbteilung(
  AbteilungID      int not null,
  PrsId            int not null,
  Von              datetime not null,
  Bis              datetime not null,
  Prozent          int not null,
  Status           int null
--constraint PK_PrsAbtID primary key (AbteilungID, PrsID)
)

create table Dienst(
  DienstID         int identity(1,1) not null,
  Name             varchar(32)       not null,
  BeschrID         int               null,
--  EinsatzProTag    int               not null,
  Gerechnet        int               not null,
  Typ              int               not null,
  RGB              int               null,
  ColorName        varchar(32)       null,
  Status           int               not null,  -- 0:Aktiv    1:Nicht aktiv
  GanzerTag        int               not null,   --1: zeit wird von Abteilung gerechnet
  mandid           char(2)           not null
--constraint PK_DienstID primary key (DienstID)
)

-- Zeiteinheit:
-- 'P' = Pause
-- 'Z' = Dienstzeiten
create table DienstZeit(
   DienstZeitID    int not null identity(1,1),
   DienstID        int not null,
   Von             datetime not null,
   Bis             datetime not null,
   Zeiteinheit     char(1) not null,
--constraint PK_DP primary key (DienstZeitID, DienstID)
)

create table Ferien(
   FerienID        int not null identity(1,1),
   PrsId           int not null,
   Von             datetime not null,
   Bis             datetime not null,
--constraint PK_Ferien primary key (FerienID)
)

-- BeschrID 1 - 500 Fr dienste
-- BeschrID 501 - 1000 fr Anstellunge
-- BeschrID 1001 - 1500 fr Abteilungen
-- BeschrID 1501 - 2000 fr Termine
create table Beschreibung(
   BeschrID        int not null, --identity(1,1)
   Kurztext        Varchar(60) null,
   Langtext        varchar(250) null,
--constraint PK_Beschr primary key (BeschrID)
)

create table Options(
   typ             varchar(30) not null,
   wert            int not null,
   zahlwert        decimal(15,2) not null,
   textwert        varchar(255) not null
)

create table Termin(
  TerminID         int not null identity(1,1),
  Name             varchar(32)       not null,
  BeschrID         int               null,
  Status           int               not null,
  DefRGB           int               not null,
  Colorname        varchar(32)       not null,
  SHG              char(1)           not null, -- Schrift oder hintergrund farbe -S: Schrift H: Hintergrund
  mandid           char(2)           not null
)

create table Terminplan(
   PlanTerminID    int not null,
   PlanID          int not null,
   PrsID           int not null,
   Datum           datetime not null,
   AbteilungID     int not null,
   TerminID        int not null,
   Name            varchar(32) not null
--   RGB             varchar(32) null
)

create table DienstSerie(
   PrsID           int not null,
   DienstID        int not null,
   AbteilungID     int not null,
   Tag             int not null,
   Typ             varchar(5) not null, --M: Monat W: Woche
   Von             datetime not null,
   bis             datetime not null,
   mandid          char(2) not null
)

create table PlanungsJahr(
   JahrID          int not null identity(1,1),
   Jahr            int not null, --2007
   von             datetime not null,
   bis             datetime not null,
   mandid          char(2) not null,
   Status          int not null
)

create table ArbeitsTage(
   ATID            int not null identity(1,1),
   JahrID          int not null,
   Name            varchar(60) not null,
   typwert         int null,
   Von             datetime not null,
   Bis             datetime not null,
   typ             int not null, -- 1: Monat   2: Feiertag
   Tage            decimal(5,2) not null, --Anzahl tage im monat an denen gearbeitet wird / anzahl bezahlte tage pro feiertag
   mandid          char(2) not null
)

create table Saldoanpassung(
   SaldoID         int identity(1,1) not null,
   PlanID          int not null,
   AbteilungID     int not null,
   PrsID           int not null,
   Datum           datetime not null,
   Grund           varchar(250) not null,
   Stunden         decimal(7,2) not null
)

create table Schemas(
   SchemaID        int not null identity(1,1),
   Name            varchar(32) not null,
   Status          int not null,
   mandid          char(2) not null
)

create table PlanSchema(
   SchemaID        int not null,
   PrsSchemaID     int not null,-- nummer fortlaufend, fngt bei jedem schema neu an
   PrsID           int not null,
   AbteilungID     int not null,
   RGB             int null,
   ColorName       varchar(32) null,
   Bezeichner      varchar(32) null
)

create table PrsVerwaltung(
   VerwaltungID    int         not null identity(1,1),
   Version         varchar(25) not null,
   name            varchar(32) not null,
   Datum           datetime    not null,
constraint PK_Verwaltung primary key (VerwaltungID)
)

create table DienstSchema(
   SchemaID        int not null,
   AbteilungID     int not null,
   DienstID        int not null,
   EinsatzProTag   int not null,
   Gerechnet       int not null
)


--create table ZusatzPerson(
--   zprsID          int not null identity(1,1),
--   Nachname        varchar(32) not null,
--   Vorname         varchar(32) not null,
--)

create table ArbeitsPlanzprs(
   planID         int not null,
   zprsID         int not null,
   abteilungID    int not null
)

--create table Dienstplanzprs(
--   PlanID          int not null,
--   zPrsID          int not null,
--   Datum           datetime not null,
--   AbteilungID     int not null,
--   DienstID        int not null,
--)

create table mandant
(
    mandid            char(2)      not null,
    name              varchar(35)  not null,
    beschreibung      varchar(250) not null,
    active            int          not null default 1
)

create table userrights
(
     userid           int             not null identity(1,1),
     username         varchar(35)     not null,
     loginname        varchar(35)     not null,
     password         varbinary(256)  not null,
     beschreibung     varchar(250)    not null,
     userrights        smallint        not null,
     mandid           char(2)         not null
)

print 'Tabellen erstellt'


----------------------------------------------------------------------------------------------
-- Alle Index constraints
----------------------------------------------------------------------------------------------
create clustered index IX_Person on Person (PrsId, Vorname, Nachname)
create clustered index IX_Anstellung on Anstellung (Prioritaet,Name)
create clustered index IX_DienstZeit on DienstZeit (DienstID,Von)
create clustered index IX_Ferien on Ferien (PrsId,Von)

create nonclustered index IX_Abteilung on Abteilung (Name)
create nonclustered index IX_Dienst on Dienst (Name)
print 'Indexes erstellt'

----------------------------------------------------------------------------------------------
-- Alle Primary Key constraints
----------------------------------------------------------------------------------------------
alter table Beschreibung add constraint PK_Beschr primary key (BeschrID)
alter table Ferien add constraint PK_Ferien primary key (FerienID)
alter table DienstZeit add constraint PK_DP primary key (DienstZeitID, DienstID)
alter table Dienst add constraint PK_DienstID primary key (DienstID)
alter table PersonalAbteilung add constraint PK_PrsAbtID primary key (AbteilungID, PrsId, Von, Bis)
alter table Abteilung add constraint PK_AbteilungID primary key (AbteilungID)
alter table ArbeitsPlan add constraint PK_ArbeitsPlan primary key (PlanID)
alter table PersonAnstellung add constraint PK_PersonAnstellung primary key (PrsID, AnstellungID, Von, Bis)
alter table Anstellung add constraint PK_AnstellungID primary key (AnstellungID)
alter table PersonZeiten add constraint PK_PersonZeit primary key (PrsID)
alter table Arbeitszeit add constraint PK_StundenID primary key (PrsID, PlanID, AbteilungID)--Check
alter table Arbeitspensum add constraint PK_Pensum primary key (PrsID, Von, Bis)
alter table Dienstplan add constraint PK_DienstPlanID primary key (PlanID, AbteilungID, PrsID, Datum)
alter table Colorplan add constraint PK_ColorPlanID primary key (PlanID, AbteilungID, PrsID, Datum)
alter table Person add constraint PK_PrsID primary key (PrsId)
alter table Options add constraint PK_Options primary key (typ, wert)
alter table Termin add constraint PK_TerminID primary key (TerminID)
alter table Terminplan add constraint PK_TerminplanID primary key (PlanTerminID, PlanID, AbteilungID, PrsID)
alter table DienstSerie add constraint PK_DienstSerie primary key (PrsID, DienstID, AbteilungID, Tag)
alter table PlanungsJahr add constraint PK_JahrID primary key (JahrID)
alter table ArbeitsTage add constraint PK_ArbeitsTage primary key (ATID)--, JahrID)
alter table Saldoanpassung add constraint PK_Saldoanpassung primary key (SaldoID, PlanID, AbteilungID, PrsID, Datum)
alter table Schemas add constraint PK_Schemas primary key (SchemaID)
alter table PlanSchema add constraint PK_PlanSchema primary key (SchemaID, PrsSchemaID)
alter table DienstSchema add constraint PK_DienstSchema primary key (SchemaID, AbteilungID, DienstID)

alter table ArbeitsPlanzprs add constraint PK_ArbeitsPlanzprs primary key (planID, zprsID, abteilungID)
alter table mandant add constraint pk_mandant primary key (mandid)
alter table userrights add constraint pk_userrights primary key (userid,loginname)
--alter table ZusatzPerson add constraint PK_ZusatzPerson primary key (zprsid)
--alter table Dienstplanzprs add constraint PK_Dienstplanzprs primary key (planid, abteilungid, zprsid, datum)
print 'Primary keys erstellt'

----------------------------------------------------------------------------------------------
-- Alle Foreign Key constraints
----------------------------------------------------------------------------------------------
alter table Ferien add constraint FK_Ferien_Person foreign key (PrsId) references Person(PrsId)
alter table Dienst add constraint FK_Dienst_Beschr foreign key (BeschrID) references Beschreibung(BeschrID)
--alter table Dienst add constraint FK_Dienst_Typ_Options foreign key (Typ) references Options(wert)
alter table PersonalAbteilung add constraint FK_Abteilung_PrsAbt foreign key (AbteilungID) references Abteilung(AbteilungID) on delete cascade
alter table PersonalAbteilung add constraint FK_PrsIdg_PrsAbt foreign key (PrsId) references Person(PrsId) on delete cascade
alter table Abteilung add constraint FK_Abt_Beschr foreign key (BeschrID) references Beschreibung(BeschrID)
alter table ArbeitsPlan add constraint FK_AP_ATID foreign key (ATID) references ArbeitsTage (ATID)
alter table ArbeitsPlan add constraint FK_AP_Jahr foreign key (JahrID) references PlanungsJahr (JahrID)
alter table ArbeitsPlan add constraint FK_AP_Schema foreign key (SchemaID) references Schemas (SchemaID)
alter table PersonAnstellung add constraint FK_Anstellung_PrsAnstellung foreign key (AnstellungID) references Anstellung(AnstellungID)
alter table PersonAnstellung add constraint FK_Prs_PrsAnstellung foreign key (PrsID) references Person(PrsId)
alter table DienstZeit add constraint FK_DP_Dienst foreign key (DienstID) references Dienst(DienstID)
alter table Arbeitszeit add constraint FK_Arbeitzeit_PrsID foreign key (PrsID) references Person(PrsId)
alter table Arbeitszeit add constraint FK_Arbeitzeit_PlanID foreign key (PlanID) references ArbeitsPlan(PlanID)
alter table Arbeitszeit add constraint FK_arbeitszeit_abteilungID foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table Dienstplan add constraint FK_Plan_PrsID foreign key (PrsID) references Person(PrsId)
alter table Colorplan add constraint FK_CPlan_PrsID foreign key (PrsID) references Person(PrsId)
alter table PersonZeiten add constraint FK_PersZeit_PrsID foreign key (PrsID) references Person(PrsId)
alter table PersonZeiten add constraint FK_PZ_Jahr foreign key (JahrID) references PlanungsJahr (JahrID)
alter table Dienstplan add constraint FK_Plan_DienstID foreign key (DienstID) references Dienst(DienstID)
alter table Dienstplan add constraint FK_Plan_PlanID foreign key (PlanID) references ArbeitsPlan(PlanID)
alter table Colorplan add constraint FK_CPlan_PlanID foreign key (PlanID) references ArbeitsPlan(PlanID)
alter table Arbeitspensum add constraint FK_Pensum_Prs foreign key (PrsID) references Person(PrsId)
alter table Anstellung add constraint FK_Anstellung_Beschr foreign key (BeschrID) references Beschreibung(BeschrID)
alter table Terminplan add constraint FK_TermPlan_PrsID foreign key (PrsID) references Person(PrsId)
alter table Terminplan add constraint FK_TermPlan_PlanID foreign key (PlanID) references ArbeitsPlan(PlanID)
alter table Terminplan add constraint FK_TermPlan_AbteilungID foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table Terminplan add constraint FK_TermPlan_TerminID foreign key (TerminID) references Termin(TerminID)
alter table DienstSerie add constraint FK_DienstSerie_PrsID foreign key (PrsID) references Person(PrsId)
alter table DienstSerie add constraint FK_DienstSerie_DienstID foreign key (DienstID) references Dienst(DienstID)
alter table DienstSerie add constraint FK_DienstSerie_AbteilungID foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table ArbeitsTage add constraint FK_JahrID foreign key (JahrID) references PlanungsJahr(JahrID)
alter table Saldoanpassung add constraint FK_Saldoanpassung_PrsID foreign key (PrsID) references Person(PrsId)
alter table Saldoanpassung add constraint FK_Saldoanpassung_AbteilungID foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table Saldoanpassung add constraint FK_Saldoanpassung_PlanID foreign key (PlanID) references ArbeitsPlan(PlanID)
alter table PlanSchema add constraint FK_PlanSchema_SchemaID foreign key (SchemaID) references Schemas(SchemaID)
--alter table PlanSchema add constraint FK_PlanSchema_PrsID foreign key (PrsID) references Person(PrsID) -- wegen lehren eintrgen in der tabelle
alter table PlanSchema add constraint FK_PlanSchema_AbteilungID foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table DienstSchema add constraint FK_DienstSchema_Schema foreign key (SchemaID) references Schemas(SchemaID)
alter table DienstSchema add constraint FK_DienstSchema_Abteilung foreign key (AbteilungID) references Abteilung(AbteilungID)
alter table DienstSchema add constraint FK_DienstSchema_Dienst foreign key (DienstID) references Dienst(DienstID)
alter table ArbeitsPlanzprs add constraint FK_ArbeitsPlanzprs_plan foreign key (planID) references ArbeitsPlan(PlanID)
alter table ArbeitsPlanzprs add constraint FK_ArbeitsPlanzprs_zprs foreign key (zprsID) references Person(PrsId)
alter table ArbeitsPlanzprs add constraint FK_ArbeitsPlanzprs_abteilung foreign key (abteilungID) references Abteilung(AbteilungID)
alter table PlanungsJahr add constraint FK_planungsjahr_mandant foreign key (mandid) references mandant(mandid)
--alter table Dienstplanzprs add constraint FK_Dienstplanzprs_zprs foreign key (zprsid) references zusatzperson(zprsid)
--alter table Dienstplanzprs add constraint FK_Dienstplanzprs_abteilung foreign key (abteilungid) references abteilung(abteilungid)
--alter table Dienstplanzprs add constraint FK_Dienstplanzprs_dienst foreign key (dienstid) references dienst(dienstid)
alter table Person add constraint FK_Person_mandant foreign key (mandid) references mandant(mandid)
alter table Schemas add constraint FK_Schemas_mandant foreign key (mandid) references mandant(mandid)
alter table Anstellung add constraint FK_Anstellung_mandant foreign key (mandid) references mandant(mandid)
alter table Abteilung add constraint FK_Abteilung_mandant foreign key (mandid) references mandant(mandid)
alter table Termin add constraint FK_Termin_mandant foreign key (mandid) references mandant(mandid)
alter table ArbeitsTage add constraint FK_ArbeitsTage_mandant foreign key (mandid) references mandant(mandid)
alter table DienstSerie add constraint FK_DienstSerie_mandant foreign key (mandid) references mandant(mandid)
alter table userrights add constraint fk_userrights_mandant foreign key (mandid) references mandant (mandid) on delete cascade
alter table Dienst add constraint fk_dienst_mandid foreign key (mandid) references mandant (mandid) on delete cascade
alter table ArbeitsPlan add constraint fk_arbeitsplan_mandid foreign key (mandid) references mandant (mandid) on delete cascade

print 'Foreign keys erstellt'

----------------------------------------------------------------------------------------------
-- User erstellen
----------------------------------------------------------------------------------------------
use master
go
if not exists (select 1 from syslogins where loginname = 'prsadmin')
begin 
   exec master.dbo.sp_addlogin @loginame = N'prsadmin', @passwd = 'Personalplaner01', @defdb = N'master', @deflanguage = N'Deutsch'
   exec sp_password NULL, 'personalplaner', 'prsadmin'
   print 'Login: prsadmin erstellt'
end
if not exists (select 1 from syslogins where loginname = 'prsuser')
begin 
   exec master.dbo.sp_addlogin @loginame = N'prsuser', @passwd = 'Personalplaner01', @defdb = N'master', @deflanguage = N'Deutsch'
   exec sp_password NULL, 'personalplaner', 'prsuser'
   print 'Login: prsuser erstellt'
end

----------------------------------------------------------------------------------------------
-- User und Rolle der DB zuweisen
----------------------------------------------------------------------------------------------
use Personalplaner
go
if not exists (select 1 from sysusers where name like 'prsadmin')
begin
   exec sp_addrole @rolename = N'prsadmins', @ownername = N'dbo'
   exec dbo.sp_grantdbaccess @loginame = N'prsadmin', @name_in_db = N'prsadmin'
   exec dbo.sp_addrolemember @rolename = N'prsadmins', @membername = N'prsadmin'
   print 'User: prsadmin erstellt'
end

if not exists (select 1 from sysusers where name like 'prsuser')
begin
   exec sp_addrole @rolename = N'prsusers', @ownername = N'dbo'
   exec dbo.sp_grantdbaccess @loginame = N'prsuser', @name_in_db = N'prsuser'
   exec dbo.sp_addrolemember @rolename = N'prsusers', @membername = N'prsuser'
   print 'User: prsuser erstellt'
end


----------------------------------------------------------------------------------------------
-- User Berechtigungen auf Tabellen geben
----------------------------------------------------------------------------------------------
grant select, insert, delete, update on PrsVerwaltung to prsadmins with grant option
grant select, insert, delete, update on Dienstplan to prsadmins with grant option
grant select, insert, delete, update on Colorplan to prsadmins with grant option
grant select, insert, delete, update on Person to prsadmins with grant option
grant select, insert, delete, update on Arbeitspensum to prsadmins with grant option
grant select, insert, delete, update on Arbeitszeit to prsadmins with grant option
grant select, insert, delete, update on Anstellung to prsadmins with grant option
grant select, insert, delete, update on ArbeitsPlan to prsadmins with grant option
grant select, insert, delete, update on Abteilung to prsadmins with grant option
grant select, insert, delete, update on PersonalAbteilung to prsadmins with grant option
grant select, insert, delete, update on Dienst to prsadmins with grant option
grant select, insert, delete, update on DienstZeit to prsadmins with grant option
grant select, insert, delete, update on Ferien to prsadmins with grant option
grant select, insert, delete, update on Beschreibung to prsadmins with grant option
grant select, insert, delete, update on PersonAnstellung to prsadmins with grant option
grant select, insert, delete, update on PersonZeiten to prsadmins with grant option
grant select, insert, delete, update on Options to prsadmins with grant option
grant select, insert, delete, update on Termin to prsadmins with grant option
grant select, insert, delete, update on Terminplan to prsadmins with grant option
grant select, insert, delete, update on DienstSerie to prsadmins with grant option
grant select, insert, delete, update on PlanungsJahr to prsadmins with grant option
grant select, insert, delete, update on ArbeitsTage to prsadmins with grant option
grant select, insert, delete, update on Saldoanpassung to prsadmins with grant option
grant select, insert, delete, update on Schemas to prsadmins with grant option
grant select, insert, delete, update on PlanSchema to prsadmins with grant option
grant select, insert, delete, update on DienstSchema to prsadmins with grant option
grant select, insert, delete, update on ArbeitsPlanzprs to prsadmins with grant option
grant select, insert, delete, update on mandant to prsadmins with grant option
grant select, insert, delete, update on userrights to prsadmins with grant option


grant select, insert, delete, update on Dienstplan to prsusers
grant select, insert, delete, update on Colorplan to prsusers
grant select, insert, delete, update on PersonZeiten to prsusers
grant select, insert, delete, update on Arbeitszeit to prsusers
grant select, insert, delete, update on ArbeitsPlan to prsusers
grant select, insert, delete, update on Ferien to prsusers
grant select, insert, delete, update on Beschreibung to prsusers
grant select, insert, delete, update on Options to prsusers
grant select, insert, delete, update on Termin to prsusers
grant select, insert, delete, update on Terminplan to prsusers
grant select, insert, delete, update on DienstSerie to prsusers
grant select, insert, delete, update on PlanungsJahr to prsusers
grant select, insert, delete, update on ArbeitsTage to prsusers
grant select, insert, delete, update on Saldoanpassung to prsusers
grant select, insert, delete, update on Schemas to prsusers
grant select, insert, delete, update on PlanSchema to prsusers
grant select, insert, delete, update on mandant to prsusers
grant select, insert, delete, update on userrights to prsusers
grant select on PrsVerwaltung to prsusers
grant select on Person to prsusers
grant select on Arbeitspensum to prsusers
grant select on Anstellung to prsusers
grant select on Abteilung to prsusers
grant select on PersonalAbteilung to prsusers
grant select on Dienst to prsusers
grant select on DienstZeit to prsusers
grant select on PersonAnstellung to prsusers
grant select on DienstSchema to prsusers
grant select, insert, delete, update on ArbeitsPlanzprs to prsusers




----------------------------------------------------------------------------------------------
-- Datenbankversion zur Kontrolle ob die richtige DB
-- beim Login ausgewhlt wurde
----------------------------------------------------------------------------------------------
insert into PrsVerwaltung (Version, name, Datum) values ('2.0.0', 'Personalplaner', GETDATE()) 