
if exists (select 1 from sysobjects where name = 'get_arbeitspensum' and type = 'P')
begin
   drop procedure get_arbeitspensum
   print 'Procedure: get_arbeitspensum deleted ...'
end
go
create procedure get_arbeitspensum(
  @prsid              int           = 7,
  @abteilungid        int           = 0
)
as
begin
  set nocount on
  
  select abteilungid = PersonalAbteilung.AbteilungID,
         pensum = Prozent,
         von    = Von,
         bis    = Bis,
         a.Name    
    from PersonalAbteilung 
   inner join Abteilung a
      on a.AbteilungID = PersonalAbteilung.AbteilungID
   where PrsId = @prsid 
     and (PersonalAbteilung.AbteilungID = @abteilungid or @abteilungid = 0)
     and getdate() >= Von 
     and getdate() <= Bis

  

end
go
print 'Procedure: get_arbeitspensum done ...'
go
grant exec on get_arbeitspensum to prsadmins with grant option
go
grant exec on get_arbeitspensum to prsusers
go

