if exists (select 1 from sysobjects where name = 'get_plandienstserie' and type = 'P')
begin
   drop procedure get_plandienstserie
   print 'Procedure: get_plandienstserie deleted ...'
end
go
create procedure get_plandienstserie(
    @planid     int = 1
)
as
begin
  set nocount on

  declare @datumvon   datetime
  declare @datumbis   datetime

  create table #dienstserie
  (
     prsid         int,
     dienstid      int,
     abteilungid   int,
     tag           int,
     typ           int,
     von           datetime,
     bis           datetime,
     planvon       datetime,
     planbis       datetime
  )
  
  select @datumvon = Von,
         @datumbis = Bis
    from ArbeitsPlan
   where PlanID = @planid

  insert #dienstserie
  select prsid = ds.PrsID,
         dienstid = ds.DienstID,
         abteilungid = ds.AbteilungID,
         tag = ds.Tag,
         typ = ds.Typ,
         von = ds.Von, 
         bis = ds.bis,
         planvon = @datumvon,
         planbis = @datumbis
   from DienstSerie ds
  where ((Von <= @datumvon and bis >= @datumbis)          -- bis
       or (Von >= @datumvon and bis >= @datumbis and Von <= @datumbis)
       or (Von <= @datumvon and bis >= @datumbis)
			           										-- von
       or (Von <= @datumvon and bis <= @datumbis and bis >= @datumvon)
       or (Von >= @datumvon and bis <= @datumbis))
       
   select * from #dienstserie

end
go
print 'Procedure: get_plandienstserie done ...'
go

grant exec on get_plandienstserie to prsadmins with grant option
go
grant exec on get_plandienstserie to prsusers
go

