
if exists (select 1 from sysobjects where name = 'set_newpensum' and type = 'P')
begin
   drop procedure set_newpensum
   print 'Procedure: set_newpensum deleted ...'
end
go
create procedure set_newpensum(
  @prsid             int           = 1,
  @pensum            int           = 1,
  @von               varchar(8)    = '00000000',
  @bis               varchar(8)    = '00000000'
)
as
begin
  set nocount on

  declare @pvon datetime
  declare @pbis datetime

  select @pvon = convert(datetime,@von,112)
  select @pbis = convert(datetime,@bis,112)

  -- reset pld bis to new von
  update Arbeitspensum
     set Bis = @pvon
   where PrsID = @prsid
     and Status = 1

  -- set all status to 2
  update Arbeitspensum
     set Status = 2
   where PrsID = @prsid

  -- ueberflssige pensen lschen
  delete from Arbeitspensum where Von = Bis and PrsID = @prsid
  delete from Arbeitspensum where Von >= @pvon and Bis >= @pbis and PrsID = @prsid
  delete from Arbeitspensum where Von >= @pvon and Bis >= @pvon and PrsID = @prsid
  
  update Arbeitspensum
     set Bis = @pvon
   where Bis > @pvon
     and Status = 2
     and PrsID = @prsid

  -- insert new pensum
  insert into Arbeitspensum (PrsID, Von, Bis, Prozent, Status) 
      values (@prsid, @pvon, @pbis, @pensum,1)

  -- Anstellungsdatum ndern
  update PersonAnstellung
     set Bis = @pbis--@pvon--@pbis
   where PrsID = @prsid
     and Bis > @pvon
     
  -- Person als angestellte darstellen
  if exists (select 1 from Person where PrsId = @prsid and PersonTyp <> 1)
	  update Person 
		 set PersonTyp = 1
	   where PrsId = @prsid

end
go
print 'Procedure: set_newpensum done ...'
go
grant exec on set_newpensum to prsadmins with grant option
go
grant exec on set_newpensum to prsusers
go
