if exists (select 1 from sysobjects where name = 'set_planungsjahr' and type = 'P')
begin
   drop procedure set_planungsjahr
   print 'Procedure: set_planungsjahr deleted ...'
end
go

create procedure set_planungsjahr(
  @jahr          int   = 1900,
  @mandid        char(2) = 'li',
  @von           varchar(8) = '20070101',
  @bis           varchar(8) = '20071231'
)
as
begin

  set nocount on

  declare @datevon datetime
  declare @datebis datetime

  select @datevon = convert(datetime, @von, 112)
  select @datebis = convert(datetime, @bis, 112)

  -- Alle alten jahre status auf 2 setzten
  update PlanungsJahr set Status = 2 where Status = 1

  -- neues jahr erstellen mit aktivem status
  insert into PlanungsJahr (Jahr,von,bis,mandid,Status) values (@jahr,@datevon,@datebis,@mandid,1)
  
  select * from PlanungsJahr

end
go
print 'Procedure: set_planungsjahr done ...'
go
grant exec on set_planungsjahr to prsadmins with grant option
go
grant exec on set_planungsjahr to prsusers
go

