if exists (select 1 from sysobjects where name = 'set_saldoanpassung' and type = 'P')
begin
   drop procedure set_saldoanpassung
   print 'Procedure: set_saldoanpassung deleted ...'
end
go
-- setzt anzahl tage pro monat fest
create procedure set_saldoanpassung(
  @PlanID          int = 1,
  @abteilungid     int = 1,
  @PrsID           int = 1,
  @Datum           varchar(8) = '20071111',
  @Grund           varchar(250) = 'zu spt',
  @Stunden         decimal(7,2) = 5,
  @retval          int = 0 output 
)
as
begin

  set nocount on

  declare @date datetime

  select @date = convert(datetime, @Datum, 112)
--sp_help saldoanpassung
  insert into Saldoanpassung (PlanID,AbteilungID,PrsID,Datum,Grund,Stunden) values (@PlanID,@abteilungid,@PrsID,@date,@Grund,@Stunden)
  
  select @retval = max(SaldoID)
    from Saldoanpassung
   where PlanID = @PlanID
     and AbteilungID = @abteilungid
     and PrsID = @PrsID
     and Datum = @date
     and Grund = @Grund
     and Stunden = @Stunden

end
go

print 'Procedure: set_saldoanpassung done ...'
go

grant exec on set_saldoanpassung to prsadmins with grant option
go
grant exec on set_saldoanpassung to prsusers
go

