if exists (select 1 from sysobjects where name = 'upd_arbeitstage_feiertag' and type = 'P')
begin
   drop procedure upd_arbeitstage_feiertag
   print 'Procedure: upd_arbeitstage_feiertag deleted ...'
end
go
-- setzt anzahl tage pro monat fest
create procedure upd_arbeitstage_feiertag(
  @name          varchar(32)  = 'Ostern',
  @von           varchar(8)   = '00000000',
  @bis           varchar(8)   = '00000000',
  @tage          decimal(5,2) = 23,   --Anzahl tage im monat an denen gearbeitet wird / anzahl bezahlte tage pro feiertag 
  @atid          int          = 1
)
as
begin

  set nocount on

  update ArbeitsTage
     set Name = @name,
         Von  = convert(datetime, @von, 108),
         Bis  = convert(datetime, @bis, 108),
         Tage = @tage
   where ATID = @atid

end
go
print 'Procedure: upd_arbeitstage_feiertag done ...'
go
grant exec on upd_arbeitstage_feiertag to prsadmins with grant option
go
grant exec on upd_arbeitstage_feiertag to prsusers
go

