if exists (select 1 from sysobjects where name = 'upd_planschema' and type = 'P')
begin
   drop procedure upd_planschema
   print 'Procedure: upd_planschema deleted ...'
end
go
-- setzt anzahl tage pro monat fest
create procedure upd_planschema(
  @SchemaID        int = 1,
  @PrsSchemaID     int = 1,-- nummer fortlaufend, fngt bei jedem schema neu an
  @PrsID           int = 1,
  @AbteilungID     int = 1,
  @RGB             int = null,
  @ColorName       varchar(32) = '',
  @Bezeichner      varchar(32) = ''
)
as
begin

  set nocount on
--select * from planschema
if exists (select 1 from planschema where prsschemaid = @PrsSchemaID and schemaid = @SchemaID)
begin
  update planschema set
         prsid = @PrsID,
         abteilungid = @AbteilungID,
         rgb = @RGB,
         colorname = @ColorName,
         bezeichner = @Bezeichner
   where schemaid = @SchemaID
     and prsschemaid = @PrsSchemaID
end
else
begin
   exec set_planschema @SchemaID, @PrsSchemaID, @PrsID, @AbteilungID, @RGB, @ColorName, @Bezeichner
end

end
go

print 'Procedure: upd_planschema done ...'
go

grant exec on upd_planschema to prsadmins with grant option
go
grant exec on upd_planschema to prsusers
go

