
if exists (select 1 from sysobjects where name = 'upd_planschemaid' and type = 'P')
begin
   drop procedure upd_planschemaid
   print 'Procedure: upd_planschemaid deleted ...'
end
go
create procedure upd_planschemaid(
  @schemaid          int           = 1,
  @planid            int           = 1
)
as
begin
  set nocount on

   declare @prsid       int
   declare @abteilungid int

   create table #personen(
      planid       int,
      prsid        int,
      abteilungid  int
   )

   -- Schemanummer aktualisieren
   update arbeitsplan
      set schemaid = @schemaid
    where planid = @planid


-- Alles lschen was nicht in schema gehrt
   insert #personen
   select planid = dp.planid,
          prsid = dp.prsid,
          abteilungid = dp.abteilungid
-- select * 
     from dienstplan dp
    inner join arbeitsplan ap
       on ap.planid = dp.planid
     left outer join planschema ps
       on ps.schemaid = ap.schemaid
      and ps.prsid = dp.prsid
      and ps.abteilungid = dp.abteilungid
    where dp.planid = @planid
      and ps.prsid is null
    group by dp.prsid, dp.abteilungid, dp.planid



      declare prs_crs cursor for 
       select prsid,
              abteilungid
         from #personen
          for read only
      
      open prs_crs
      fetch next from prs_crs into @prsid, @abteilungid

      while (@@fetch_status <> -1)
      begin
         if (@@fetch_status <> -2)
         begin
            delete from dienstplan where prsid = @prsid and abteilungid = @abteilungid and planid = @planid
         end

         fetch next from prs_crs into @prsid, @abteilungid
      end

      close prs_crs
      deallocate prs_crs


end
go
print 'Procedure: upd_planschemaid done ...'
go
grant exec on upd_planschemaid to prsadmins with grant option
go
grant exec on upd_planschemaid to prsusers
go

