
if exists (select 1 from sysobjects where name = 'upd_prsabteilung' and type = 'P')
begin
   drop procedure upd_prsabteilung
   print 'Procedure: upd_prsabteilung deleted ...'
end
go
create procedure upd_prsabteilung(
  @abteilungid      int   = 1,
  @prsid            int   = 1,
  @vonnew           char(8) = '20070501',
  @bisnew           char(8) = '20090501'
)
as
begin
  set nocount on

-- Daten die berschssig sind lschen
-- will cause error if there are more than 1 that have the same begin date because enddate will be set to same...
declare @abtcount table(abteilungid int, cnt int)
 insert @abtcount
 select cnt = count(Von), 
        abteilungid = AbteilungID
   from PersonalAbteilung 
  where (AbteilungID = @abteilungid or @abteilungid =0) 
    and PrsId = @prsid 
    and Bis >= @vonnew 
  group by AbteilungID,PrsId,Von having COUNT(Von) > 1

--if @abtcount > 1
--begin
--  declare @maxbis datetime
--   select @maxbis = MAX(Bis) 
--     from PersonalAbteilung 
--    where AbteilungID = @abteilungid 
--      and PrsId = @prsid 
--      and Bis >= @bisnew having COUNT(Von) > 1
   
--   delete from PersonalAbteilung 
--    where PrsId = @prsid 
--      and AbteilungID = @abteilungid 
--      and Von = (select Von from PersonalAbteilung where AbteilungID = @abteilungid and PrsId = @prsid and Bis >= @bisnew group by AbteilungID,PrsId,Von having COUNT(Von) > 1)
--      and Bis <> @maxbis
--end

  declare @abteilungen table (abteilungid int)
   insert @abteilungen
   select abteilungid = AbteilungID
     from PersonalAbteilung 
    where PrsId = @prsid 
      and (AbteilungID = @abteilungid or @abteilungid = 0) 
      and Von = @vonnew 
      and Bis >= @vonnew
      
if exists (select * from @abteilungen)
begin
   delete PersonalAbteilung
     from PersonalAbteilung pa 
    inner join @abteilungen a
       on a.abteilungid = pa.AbteilungID
    where PrsId = @prsid 
      and Von = @vonnew
      and Bis = @vonnew
end

  -- delete all that have the same begin date as end date
  delete from PersonalAbteilung where PrsId = @prsid and Bis = Von
  --delete from PersonalAbteilung where PrsId = @prsid and Von >= @bisnew and Bis >= @bisnew
  --delete from PersonalAbteilung where PrsId = @prsid and Von >= @vonnew and (Bis <= @bisnew or
  delete from PersonalAbteilung where PrsId = @prsid and Von >= @vonnew
  
  
  update PersonalAbteilung
     set Bis = dateadd(day, -1, @vonnew),-- @vonnew,
         Status = 2
   where (AbteilungID = @abteilungid or @abteilungid = 0)
     and PrsId = @prsid
     and Bis >= @vonnew
     --and Status = 1
--   end

end
go
print 'Procedure: upd_prsabteilung done ...'
go
grant exec on upd_prsabteilung to prsadmins with grant option
go
grant exec on upd_prsabteilung to prsusers
go

