
if exists (select 1 from sysobjects where name = 'upd_prsanstellung' and type = 'P')
begin
   drop procedure upd_prsanstellung
   print 'Procedure: upd_prsanstellung deleted ...'
end
go
create procedure upd_prsanstellung(
  @prsid             int   = 1,
  @anstellungid      int   = 1,
  @von               varchar(8) = '20070101',
  @bis               varchar(8) = '20200101'
)
as
begin
   set nocount on

   declare @datevon  datetime
   declare @datebis  datetime
 
   select @datevon = convert(datetime, @von, 112)
   select @datebis = convert(datetime, @bis, 112)

   -- Datum von alter Anstellung zurcksetzen
   update personanstellung
      set bis = @datevon
    where prsid = @prsid
      and bis = (select max(pa.bis) from personanstellung pa
                                   where pa.prsid = @prsid)

   insert into personanstellung (prsid,AnstellungID,Von,Bis) values (@prsid, @anstellungid, @datevon,@datebis)

end
go
print 'Procedure: upd_prsanstellung done ...'
go
grant exec on upd_prsanstellung to prsadmins with grant option
go
grant exec on upd_prsanstellung to prsusers
go

