﻿
using System;
using System.Windows.Media;

namespace personalplaner.business.dienstplan.plancollection
{
	public class DienstOverviewRow : ListBase<DienstOverviewItem>
	{
		public void Initialize(DateTime beginDate)
		{
			int cnt = DateTime.DaysInMonth(beginDate.Year, beginDate.Month);
			for (int i = 0; i < cnt; i++)
				Add(new DienstOverviewItem
				{
					Datum = new DateTime(beginDate.Year, beginDate.Month, i + 1),
					EinsatzProTag = EinsatzProTag
				});
		}

        public int DienstId
        {
            get
            {
                return ID;
            }
            set
            {
                ID = value;
                RaisePropertyChanged("DienstId");
            }
        }

		bool _isGerechnet;
		public bool IsGerechnet
		{
			get { return _isGerechnet; }
			set
			{
				_isGerechnet = value;
				RaisePropertyChanged("IsGerechnet");
			}
		}

		int _einsatzProTag;
		public int EinsatzProTag
		{
			get { return _einsatzProTag; }
			set
			{
				_einsatzProTag = value;
				RaisePropertyChanged("EinsatzProTag");
			}
		}

		string _kurztext;
		public string Kurztext
		{
			get { return _kurztext; }
			set
			{
				_kurztext = value;
				RaisePropertyChanged("Kurztext");
			}
		}

		string _langtext;
		public string Langtext
		{
			get { return _langtext; }
			set
			{
				_langtext = value;
				RaisePropertyChanged("Langtext");
			}
		}

		int _abteilungId;
		public int AbteilungId
		{
			get { return _abteilungId; }
			set
			{
				_abteilungId = value;
				RaisePropertyChanged("AbteilungId");
			}
		}

		string _abteilung;
		public string Abteilung
		{
			get { return _abteilung; }
			set
			{
				_abteilung = value;
                RaisePropertyChanged("Abteilung");
			}
		}

		#region Coloring

		Color _headercolor;
		public Color HeaderColor
		{
			get
			{
				return _headercolor;
			}
			set
			{
				_headercolor = value;
				RaisePropertyChanged("HeaderColor");
			}
		}

		#endregion
	}
}
