﻿using System;

namespace personalplaner.business.stamm
{
    public class Feiertag : ItemBase
    {
		protected override string IsPropertyValid(string property)
		{
			if (property == "Name")
			{
				if (string.IsNullOrEmpty(Name))
					return "Es muss ein Name angegeben werden";
			}
			else if (property == "Von")
			{
				if (Von == DateTime.MinValue)
					return "Es muss ein Datum angegeben werden";
			}
			else if (property == "Tage")
			{
				if (Tage <= 0)
					return "Es muss eine Anzahl von Tagen angegeben werden";
			}

			return base.IsPropertyValid(property);
		}

        DateTime _von;
		public DateTime Von
        {
            get { return _von; }
            set
            {
                _von = value;
                RaisePropertyChanged("Von");
            }
        }

        DateTime _bis;
        public DateTime Bis
        {
            get { return _bis; }
            set
            {
                _bis = value;
                RaisePropertyChanged("Bis");
            }
        }

        int _jahrId;
        public int JahrId
        {
            get { return _jahrId; }
            set
            {
                _jahrId = value;
                RaisePropertyChanged("JahrId");
            }
        }

		int _atId;
		public int AtId
		{
			get { return _atId; }
			set
			{
				_atId = value;
				RaisePropertyChanged("AtId");
			}
		}

		double _tage;
		public double Tage
		{
			get { return _tage; }
			set
			{
				_tage = value;
				RaisePropertyChanged("Tage");
			}
		}
	}
}
