﻿using personalplaner.common.mvvm.factory;
using personalplaner.servicemodel.dataaccess;
using personalplaner.common;

namespace personalplaner.gui.common.viewmodels.factories
{
    public class InitWizardModelFactory : IFactory
	{
		#region IFactory Members
		
		public object CreateViewModel(System.Windows.DependencyObject sender)
        {
            var vm = new InitWizardViewModel(sender);

            vm.ServiceLocator.RegisterService<ICommonDataAccess>(new CommonDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IAbteilungDataAccess>(new AbteilungDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IAnstellungDataAccess>(new AnstellungDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IPersonDataAccess>(new PersonDataAccess(SettingsProvider.Settings));
            
            return vm;
		}

		#endregion
	}
}
