﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace personalplaner.gui.plugins.about
{
	/// <summary>
	/// Interaction logic for AboutView.xaml
	/// </summary>
	public partial class AboutView : UserControl
	{
		public AboutView()
		{
			InitializeComponent();
			AddHandler(Hyperlink.RequestNavigateEvent, new RoutedEventHandler(HandleRequestNavigate), false);
		}

		void HandleRequestNavigate(object sender, RoutedEventArgs e)
		{
			Hyperlink hl = (e.OriginalSource as Hyperlink);
			if (hl != null)
			{
				string navigateUri = hl.NavigateUri.ToString();
				Process.Start(new ProcessStartInfo(navigateUri));
				e.Handled = true;
			}
		}

		public string Version
		{
			get
			{
				return "v" + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Major +
					   "." +
					   System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Minor;
				//    "." +
				//    System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.Build;
			}
		}
	}
}
