﻿using personalplaner.common;
using personalplaner.common.mvvm.common;
using personalplaner.common.mvvm.factory;
using personalplaner.servicemodel.dataaccess;

namespace personalplaner.gui.stamm.viewmodels.factories
{
	public class AddPersonToSchemaFactory : IFactory
	{
		#region IFactory Members
		
		public object CreateViewModel(System.Windows.DependencyObject sender)
        {
			var vm = new AddPersonToSchemaViewModel(sender);

            if (Designer.IsDesignMode)
                return vm;

            vm.ServiceLocator.RegisterService<IPersonDataAccess>(new PersonDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IPlanSchemaDataAccess>(new PlanSchemaDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IPersonDataAccess>(new PersonDataAccess(SettingsProvider.Settings));
			
            return vm;
		}

		#endregion
	}
}
