﻿using personalplaner.common;
using personalplaner.common.mvvm.factory;
using personalplaner.servicemodel.dataaccess;

namespace personalplaner.gui.stamm.viewmodels.factories
{
    public class PersonalStammModelFactory : IFactory
	{
		#region IFactory Members
		
		public object CreateViewModel(System.Windows.DependencyObject sender)
        {
            var vm = new PersonalStammViewModel(sender);

            vm.ServiceLocator.RegisterService<IPersonDataAccess>(new PersonDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IAnstellungDataAccess>(new AnstellungDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IPensumDataAccess>(new PensumDataAccess(SettingsProvider.Settings));
            vm.ServiceLocator.RegisterService<IAbteilungDataAccess>(new AbteilungDataAccess(SettingsProvider.Settings));
            
            return vm;
		}

		#endregion
	}
}
