﻿using System;
using personalplaner.common.mvvm;

namespace personalplaner.gui.stamm.viewmodels.models
{
	public class DienstZeitWizardDatumModel : BaseModel
	{
		DateTime _von;
		public DateTime Von
		{
			get { return _von; }
			set
			{
				//_von = value;
				// set first day in month
				_von = new DateTime(value.Year, value.Month, 1);
				RaisePropertyChanged("Von");

				if (Von > Bis)
					Bis = Von.AddDays(1);
			}
		}

		DateTime _bis;
		public DateTime Bis
		{
			get { return _bis; }
			set
			{
				//_bis = value;
				// set last day in month
				_bis = new DateTime(value.Year, value.Month, DateTime.DaysInMonth(value.Year, value.Month));
				RaisePropertyChanged("Bis");

				if (Von > Bis)
					Von = Bis.AddDays(-1);
			}
		}

		bool _isZeitVonAbteilung;
		public bool IsZeitVonAbteilung
		{
			get { return _isZeitVonAbteilung; }
			set
			{
				_isZeitVonAbteilung = value;
				RaisePropertyChanged("IsZeitVonAbteilung");
			}
		}
	}
}
