﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using personalplaner.common.mvvm;
using personalplaner.business.stamm;

namespace personalplaner.gui.stamm.viewmodels.models
{
	public class SetPersonPensumModel : BaseModel
	{
		DateTime _von;
        public DateTime Von
        {
            get { return _von; }
            set
            {
                // set first day in month
                _von = new DateTime(value.Year, value.Month, 1);
                RaisePropertyChanged("Von");
            }
        }

        DateTime _bis;
        public DateTime Bis
        {
            get { return _bis; }
            set
            {
                // set last day in month
                _bis = new DateTime(value.Year, value.Month, DateTime.DaysInMonth(value.Year, value.Month));
                RaisePropertyChanged("Bis");
            }
        }

        short _prozent;
        public short Prozent
        {
            get { return _prozent; }
            set
            {
                _prozent = value;
                RaisePropertyChanged("Prozent");
            }
        }

        private bool _isKuendigung = false;
        public bool IsKuendigung
        {
            get { return _isKuendigung; }
            set
            {
                _isKuendigung = value;
                RaisePropertyChanged("IsKuendigung");
            }
        }
    }
}
