﻿using personalplaner.common;
using personalplaner.common.mvvm.factory;
using personalplaner.servicemodel.dataaccess;

namespace personalplaner.plugins.plananalysis.viewmodels.factories
{
	public class HolidayOverviewModelFactory : IFactory
	{
		#region IFactory Members

		public object CreateViewModel(System.Windows.DependencyObject sender)
		{
			var vm = new HolidayOverviewViewModel(sender);

			vm.ServiceLocator.RegisterService<ICommonDataAccess>(new CommonDataAccess(SettingsProvider.Settings));
			vm.ServiceLocator.RegisterService<IPlanDataAccess>(new PlanDataAccess(SettingsProvider.Settings));
			vm.ServiceLocator.RegisterService<IOptionsDataAccess>(new OptionsDataAccess(SettingsProvider.Settings));
			vm.ServiceLocator.RegisterService<IPersonDataAccess>(new PersonDataAccess(SettingsProvider.Settings));

			return vm;
		}

		#endregion
	}
}
