using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using Gencode.PrsCommon.App;
using Gencode.Common.SQL;

namespace Personalplaner
{
	class Feiertage
	{
		List<FeiertagNode> feiertagList = null;
		public Feiertage(int year)
		{
			feiertagList = new List<FeiertagNode>();

			GetList(year);
		}

		private void GetList(int year)
		{
			DataView dv = SimpleQuerry.ExecuteForDataView("select Name, Von, Bis, Tage, ATID from ArbeitsTage where Typ = 2 and (datepart(year,von) = " + year + " or datepart(year,bis) = " + year + ")");

			if (dv != null)
			{
				for (int i = 0; i < dv.Count; i++)
				{
					FeiertagNode node = new FeiertagNode();
					try
					{
						node.Name = dv[i].Row[0].ToString();
						node.Von = DateUtil.ConvertSqlToDate(dv[i].Row[1].ToString());
						node.Bis = DateUtil.ConvertSqlToDate(dv[i].Row[2].ToString());
						node.BezahlteTage = double.Parse(dv[i].Row[3].ToString());
						node.ATID = int.Parse(dv[i].Row[4].ToString());
					}
					catch (Exception e)
					{
						Gencode.Common.Util.ErrorHandler.LoggError("Feiertage list conversion", "Feiertage.GetList(int year)", e.Message);
						Gencode.Common.Util.ErrorHandler.ShowError("Es konnten nicht alle Feiertage wieder hergestellt werden.\nKontaktieren Sie ihren Systemadministrator falls diese Fehlermeldung fters erscheint", "Fehler");
					}
					finally
					{
						feiertagList.Add(node);
					}
				}
			}
		}

		public List<FeiertagNode> FeiertagList
		{
			get { return feiertagList; }
		}
	}
}
