using System;
using System.Collections.Generic;
using System.Text;
using Gencode.PrsCommon.App;
using Gencode.Common.SQL;

namespace Personalplaner
{
	class FeiertageDB
	{
		public void SaveFeiertag(string year, string name, string von, string bezahlteTage)
		{
			Querry stp = new Querry();

			stp.SetSTPName("set_arbeitstage");

			stp.AddParameter("@jahr", year);
			stp.AddParameter("@name", name);
			stp.AddParameter("@typwert", 0);
			stp.AddParameter("@von", DateUtil.ConvertDateToSQL(von));
			stp.AddParameter("@bis", DateUtil.ConvertDateToSQL(von));
			stp.AddParameter("@typ", 2); //1: Monat   2: Feiertag
			stp.AddParameter("@tage", bezahlteTage);
            stp.AddParameter("@mandid", "");

			stp.Execute();
		}

		public void UpdateFeiertag(string name, string von, string bezahlteTage, int atid)
		{
			Querry stp = new Querry();

			stp.SetSTPName("upd_arbeitstage_feiertag");

			stp.AddParameter("@name", name);
			stp.AddParameter("@von", DateUtil.ConvertDateToSQL(von));
			stp.AddParameter("@bis", DateUtil.ConvertDateToSQL(von));
			stp.AddParameter("@tage", bezahlteTage);
			stp.AddParameter("@atid", atid);

			stp.Execute();
		}
	}
}
