using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using Gencode.PrsCommon.App;

namespace Personalplaner
{
    class PersonJPRow : IPersonRow
    {
        List<IPersonColumn> column = new List<IPersonColumn>();

        int planID;
        string planName;
        int abteilungID;
        string abteilungName;
        int prsID;
		string monatName;

        public void SetData()
        {
            List<string> feiertage = new List<string>();

            if (column.Count > 0)
                column.Clear();

            string datumer = string.Empty;
            if (!Alles)
            {
                if (Feiertage)
                {
                    DataView datumDV = Gencode.PrsCommon.App.AppData.DataGenerator.GetFeiertageProPlan(planID);
                    for (int c = 0; c < datumDV.Count; c++)
                    {
                        feiertage.Add(DateUtil.ConvertSqlToDate(datumDV[c].Row[0].ToString()));
                        datumer += DateUtil.ConvertDateToSQL(feiertage[feiertage.Count - 1]);
                    }
                    datumDV.Dispose();
                }
                if (Weekend)
                {
                    DataView tmpDate = Gencode.Common.SQL.SimpleQuerry.ExecuteForDataView("select von from arbeitsplan where planid = " + planID);
                    string von = DateUtil.ConvertSqlToDate(tmpDate[0].Row[0].ToString());

                    int y = int.Parse(DateUtil.GetYear(von));
                    int m = int.Parse(DateUtil.GetMonth(von));
                    int daysCnt = DateTime.DaysInMonth(y, m);
                    tmpDate.Dispose();

                    for (int d = 1; d <= daysCnt; d++)
                    {
                        DateTime dt = new DateTime(y,m,d);
                        if (/*dt.DayOfWeek == DayOfWeek.Saturday || */dt.DayOfWeek == DayOfWeek.Sunday)
                                datumer += DateUtil.ConvertDateToSQL(dt.ToString());
                    }
                }
                //TODO:
                //Wochenenden noch dazunehmen und in 
                //datumer abfllen
            }
            if (DienstIDs == null)
                DienstIDs = string.Empty;

            Int16 all = 0;
            if (Alles)
                all = 1;


            Gencode.Common.SQL.Querry querry = new Gencode.Common.SQL.Querry();
            querry.SetSTPName("get_personjpcolumn");
            querry.AddParameter("@prsid", prsID);
            querry.AddParameter("@abteilungid", abteilungID);
            querry.AddParameter("@planid", planID);
            querry.AddParameter("@dienstids", DienstIDs);
            querry.AddParameter("@datumer", datumer);
            querry.AddParameter("@selectall", all);

            DataView dv = querry.ExecuteForDataView();

            if (GPerson.ShowPlanName == 1)
            {
                PPlanColumn tmpPlanCol = new PPlanColumn();
                tmpPlanCol.Name = planName;
                column.Add(tmpPlanCol);
            }

            if (GPerson.ShowMonth == 1)
            {
                PMonthColumn tmpMonth = new PMonthColumn();
				tmpMonth.Name = monatName;
                column.Add(tmpMonth);
            }

            if (dv.Count > 0)
            {
				string date = DateUtil.ConvertSqlToDate(dv[0].Row[0].ToString());
                string colDate = "";
				int m = int.Parse(DateUtil.GetMonth(date));
				int y = int.Parse(DateUtil.GetYear(date));
                string ms;

                if (m < 10)
                {
                    ms = "0" + m;
                }
                else
                {
                    ms = m.ToString();
                }

                int days = DateTime.DaysInMonth(y, m);

                PDienstColumn tmpJP = null;

                for (int d = 1; d <= days; d++)
                {
                    if (d < 10)
                    {
						colDate = "0" + d + "." + ms + "." + y;
                    }
                    else
                    {
						colDate = d + "." + ms + "." + y;
                    }

                    tmpJP = new PDienstColumn();
                    for (int c = 0; c < dv.Count; c++)
                    {
						if (DateUtil.ConvertSqlToDate(dv[c].Row[0].ToString()) == colDate)
                        {
                            tmpJP.Date = dv[c].Row[0].ToString();
                            tmpJP.Name = dv[c].Row[1].ToString();
                            tmpJP.DienstID = Int32.Parse(dv[c].Row[2].ToString());
                            tmpJP.ColorName = dv[c].Row[3].ToString();
                            tmpJP.RGB = Int32.Parse(dv[c].Row[4].ToString());

                            c = dv.Count;
                        }
                    }
                    DateTime dte = new DateTime(y, m, d);
                    if (dte.DayOfWeek == DayOfWeek.Saturday)
                    {
                        tmpJP.Weekend = GPerson.WEEKEND.Saturday;
                    }
                    else if (dte.DayOfWeek == DayOfWeek.Sunday)
                    {
                        tmpJP.Weekend = GPerson.WEEKEND.Sunday;
                    }

                    for (int i = 0; i < feiertage.Count; i++)
                    {
                        if (feiertage[i].ToString() == dte.ToShortDateString())
                        {
                            tmpJP.Weekend = GPerson.WEEKEND.Feiertag;
                            feiertage.RemoveAt(i);
                        }
                    }

                    column.Add(tmpJP);
                }
            }
            else
            {
                DataView dateView = Gencode.Common.SQL.SimpleQuerry.ExecuteForDataView("select von from arbeitsplan where planid = " + planID);
				int m = int.Parse(DateUtil.GetMonth(DateUtil.ConvertSqlToDate(dateView[0].Row[0].ToString())));
				int y = int.Parse(DateUtil.GetYear(DateUtil.ConvertSqlToDate(dateView[0].Row[0].ToString())));
                int days = DateTime.DaysInMonth(y, m);
                
                PDienstColumn tmpJP = null;

                for (int d = 1; d <= days; d++)
                {
                    tmpJP = new PDienstColumn();
                    if (new DateTime(y, m, d).DayOfWeek == DayOfWeek.Saturday)
                    {
                        tmpJP.Weekend = GPerson.WEEKEND.Saturday;
                    }
                    else if (new DateTime(y, m, d).DayOfWeek == DayOfWeek.Sunday)
                    {
                        tmpJP.Weekend = GPerson.WEEKEND.Sunday;
                    }
                    column.Add(tmpJP);
                }
            }
            if (GPerson.ShowSaldo == 1)
            {
                PSaldoColumn tmpSaldo = new PSaldoColumn();
                if (dv.Count > 0)
                {
                    tmpSaldo.Soll = Double.Parse(dv[0].Row[7].ToString());
                    tmpSaldo.Haben = Double.Parse(dv[0].Row[8].ToString());
                    tmpSaldo.Ferien = Double.Parse(dv[0].Row[9].ToString());
                    tmpSaldo.Anpassung = Double.Parse(dv[0].Row[10].ToString());
                }
                column.Add(tmpSaldo);
            }

            //Loop for Date if no Dienst is set
            int dateIndex = 1;
            int cl = 0;
            while (cl < column.Count)
            {
                if (column[cl] is PDienstColumn)
                {
                    if (column[cl].Caption == string.Empty)
                    {
                        if (dateIndex < 10)
                        {
                            column[cl].Caption = "0" + dateIndex;
                        }
                        else
                        {
                            column[cl].Caption = dateIndex.ToString();
                        }
                    }
                    dateIndex++;
                }
                cl++;
            }

        }

        #region Properties
        public List<IPersonColumn> Column
        {
            get { return column; }
            set { column = value; }
        }
        public string PlanName
        {
            get { return planName; }
            set { planName = value; }
        }
        public int PlanID
        {
            get { return planID; }
            set { planID = value; }
        }
        public string AbteilungName
        {
            get { return abteilungName; }
            set { abteilungName = value; }
        }
        public int AbteilungID
        {
            get { return abteilungID; }
            set { abteilungID = value; }
        }
        public int PrsID
        {
            get { return prsID; }
            set { prsID = value; }
        }
		public string MonatName
		{
			get { return monatName; }
			set { monatName = value; }
		}

        public string DienstIDs
        {
            get;
            set;
        }

        public bool Weekend
        {
            get;
            set;
        }

        public bool Feiertage
        {
            get;
            set;
        }

        public bool Alles
        {
            get;
            set;
        }

        #endregion
    }
}
