using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
//using System.Data.SqlClient;
using System.Data.Odbc;
using System.Windows.Forms;
using System.Globalization;
using Gencode.Common.SQL;
using Gencode.PrsCommon.App;

namespace Personalplaner
{
    class SetZeit
    {

        public SetZeit()
        {
        }

        public static void SetFerienZeit(string conString, int prsID, string zeitVon, string zeitBis)
        {
			Querry stp = new Querry();

            stp.SetSTPName(conString);

            stp.AddParameter("@prsid", prsID);
            stp.AddParameter("@von", DateChange(zeitVon));
            stp.AddParameter("@bis", DateChange(zeitBis));

            stp.Execute();
        }

        public static void SetDienstZeit(int dienstid, string zeitVon, string zeitBis, string zeitEinheit,string datevon,string datebis, bool abteilungszeit)
        {
			Querry stp = new Querry();

			stp.SetSTPName("set_zeit");

            stp.AddParameter("@prsid", dienstid);
            stp.AddParameter("@von", zeitVon);
            stp.AddParameter("@bis", zeitBis);
            stp.AddParameter("@zeiteinheit", zeitEinheit);
			stp.AddParameter("@datevon", DateUtil.ConvertDateToSQL(datevon));
			stp.AddParameter("@datebis",DateUtil.ConvertDateToSQL(datebis));
			if (abteilungszeit)
				stp.AddParameter("@abteilungszeit", 1);
			else
				stp.AddParameter("@abteilungszeit", 0);

            stp.Execute();
        }

        private static string DateChange(string date)
        {
            return String.Format(CultureInfo.CurrentCulture, "{0}{1}{2}{3}{4}{5}{6}{7}", date[6], date[7], date[8], date[9], date[3], date[4], date[0], date[1]);
        }
    }
}
