using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.PrsCommon.Data.Plan;
using Gencode.PrsCommon.Data.Person;

namespace Personalplaner
{
	public partial class AddPrsToSchemaDlg : Form //UserControl, Dialog.IDialogControl //
    {
		DataView m_abteilungen;
		DataView m_personen;
        int schemaID;

        public AddPrsToSchemaDlg(int schemaID)
        {
            InitializeComponent();
            this.schemaID = schemaID;

			SetComboAbteilungData();
			SetComboPersonData();
        }

        private void SetComboAbteilungData()
        {
			if (m_abteilungen != null)
				m_abteilungen.Dispose();

			m_abteilungen = PlanData.GetAbteilungenInSchema(schemaID);
			comboAbteilung.DataSource = m_abteilungen;
			comboAbteilung.DisplayMember = "name";
        }

		private void SetComboPersonData()
		{
			if(m_personen != null)
				m_personen.Dispose();

			m_personen = PersonData.GetPersonen(Verwaltung.Mandant);
			comboPerson.DataSource = m_personen;
			comboPerson.DisplayMember = "anzeigename";

			//if (comboAbteilung.SelectedIndex >= 0)
			//{
			//    m_personen = PlanData.GetPersonenInAbteilungAndSchema(int.Parse(m_abteilungen[comboAbteilung.SelectedIndex].Row["abteilungid"].ToString()),
			//        schemaID);
			//    comboPerson.DataSource = m_personen;
			//    comboPerson.DisplayMember = "anzeigename";
			//}
		}

        private void btnOK_Click(object sender, EventArgs e)
        {
			bool check = true;

			if (checkEmpty.Checked == false)
			{
				if (comboPerson.SelectedIndex < 0 || comboAbteilung.SelectedIndex < 0)
					check = false;
			}
			else
			{
				if (comboAbteilung.SelectedIndex < 0)
					check = false;
			}

			if (check)
			{
				// Person exists in abteilung
				if (!checkIfExists())
				{
					if (checkEmpty.Checked == false)
					{
						PrsID = int.Parse(m_personen[comboPerson.SelectedIndex].Row["prsid"].ToString());
					}
					else
					{
						// Empty row
						PrsID = -1;
					}
				}
				else
				{
					MessageBox.Show("\nEs ist ein Fehler bei der Auswahl aufgetreten.\n\nBitte eine andere Abteilung oder eine andere Person auswhlen\n\nDie ausgewhlte Person existiert bereits in der ausgewhlen Abteilung", "Fehler", MessageBoxButtons.OK);
					return;
				}
			}
			else
			{
				MessageBox.Show("Es ist ein Fehler bei der Auswahl aufgetreten.\n\nBitte eine Abteilung und eine Person auswhlen.", "Fehler", MessageBoxButtons.OK);
				return;
			}

			DialogResult = DialogResult.OK;
        }

		private bool checkIfExists()
		{
			if (checkEmpty.Checked == false)
			{
				return PlanData.CheckIfPersonExistsInSchema(int.Parse(m_personen[comboPerson.SelectedIndex].Row["prsid"].ToString()),
					int.Parse(m_abteilungen[comboAbteilung.SelectedIndex].Row["abteilungid"].ToString()),
					schemaID);
			}
			else
				return false;
		}

        private void btnCancel_Click(object sender, EventArgs e)
        {
			DialogResult = DialogResult.Cancel;
        }

		public int PrsID
		{
			get;
			set;
		}

        public int AbteilungID
        {
            get { return int.Parse(m_abteilungen[comboAbteilung.SelectedIndex].Row["abteilungid"].ToString()); }
        }

        private void checkEmpty_CheckedChanged(object sender, EventArgs e)
        {
            switch (checkEmpty.Checked)
            {
                case true:
                    comboPerson.SelectedIndex = -1;
                    comboPerson.Enabled = false;
                    break;
                case false:
                    comboPerson.Enabled = true;
                    break;
            }
        }

		//private void comboAbteilung_SelectedIndexChanged(object sender, EventArgs e)
		//{
		//    //if (comboAbteilung.SelectedIndex >= 0)
		//    //    SetComboPersonData();
		//}

		#region IDialogControl Members

		//public bool OKClicked()
		//{
		//    bool check = true;

		//    if (checkEmpty.Checked == false)
		//    {
		//        if (comboPerson.SelectedIndex < 0 || comboAbteilung.SelectedIndex < 0)
		//            check = false;
		//    }
		//    else
		//    {
		//        if (comboAbteilung.SelectedIndex < 0)
		//            check = false;
		//    }

		//    if (check)
		//    {
		//        // Person exists in abteilung
		//        if (!checkIfExists())
		//        {
		//            if (checkEmpty.Checked == false)
		//            {
		//                PrsID = int.Parse(m_personen[comboPerson.SelectedIndex].Row["prsid"].ToString());
		//            }
		//            else
		//            {
		//                // Empty row
		//                PrsID = -1;
		//            }
		//        }
		//        else
		//        {
		//            MessageBox.Show("\nEs ist ein Fehler bei der Auswahl aufgetreten.\n\nBitte eine andere Abteilung oder eine andere Person auswhlen\n\nDie ausgewhlte Person existiert bereits in der ausgewhlen Abteilung", "Fehler", MessageBoxButtons.OK);
		//            return false;
		//        }
		//    }
		//    else
		//    {
		//        MessageBox.Show("Es ist ein Fehler bei der Auswahl aufgetreten.\n\nBitte eine Abteilung und eine Person auswhlen.", "Fehler", MessageBoxButtons.OK);
		//        return false;
		//    }

		//    return true;
		//}

		//public bool CancleClicked()
		//{
		//    //just close
		//    return true;
		//}

		#endregion
	}
}