using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.Common.SQL;
using Gencode.PrsCommon.Data.Person;

namespace Personalplaner
{
    [ToolboxItem(false)]
	public partial class AnstellungDlg : UserControl, Gencode.Gengui.Forms.IDialogControl// Form
	{
		int prsID;
		int anstellungid;

		public AnstellungDlg(int prsID, int anstellungid)
		{
			InitializeComponent();

			this.prsID = prsID;
			this.anstellungid = anstellungid;
			comboAnstellung.InitData(Verwaltung.Mandant);
			comboAnstellung.SetIndexAt(anstellungid);
		}

		private bool SaveData()
		{
			bool set = true;

			if(comboAnstellung.SelectedAnstellungID <= 0)
			{
				MessageBox.Show("Keine Anstellung ausgewhlt.", "", MessageBoxButtons.OK);
				comboAnstellung.Focus();
				set = false;
			}

			if (von.Value > bis.Value)
			{
				MessageBox.Show("Datum Von ist grsser als Datum Bis.", "", MessageBoxButtons.OK);
				bis.Focus();
				set = false;
			}

			if (set)
			{
				PersonData.SetAnstellungToPerson(prsID, comboAnstellung.SelectedAnstellungID, von.Text, bis.Text);
			}

			return set;
		}

		#region IDialogControl Members

		public bool OKClicked()
		{
			if (SaveData())
				return true;

			return false;
		}

		public bool CancleClicked()
		{
			return true;
		}

		#endregion
	}
}