using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.PrsCommon.Data.Dienst;

namespace Personalplaner
{
    public partial class DienstSerieDlg : Form
    {
		int old_prsid, old_abteilungid, old_dienstid, old_tag;
		string old_von, old_bis, old_typ;

        string typ;
        bool changed = false;

        public DienstSerieDlg()
        {
            InitializeComponent();

            setComboTyp();

			comboDienst.InitData(Verwaltung.Mandant);
			comboPrs.InitData(Verwaltung.Mandant);
			comboAbteilung.InitData(Verwaltung.Mandant);
			comboDienstSerie.InitData(Verwaltung.Mandant);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (changed)
            {
                if (MessageBox.Show("nderungen speichern?", "", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    save();
            }

            this.Close();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (!changed)
            {
                save();
            }
            else
            {
                update();
            }

        }

        private void save()
        {
            if (typ == "M" && Convert.ToInt32(txtTag.Text) > 30) { MessageBox.Show("Tag hat keine gltige Zahl", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            if (typ == "W" && Convert.ToInt32(txtTag.Text) > 7) { MessageBox.Show("Tag hat keine gltige Zahl", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            if (txtTag.Text == "") { MessageBox.Show("Bite geben Sie einen Tag ein", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            if (comboDienst.Text == "") { MessageBox.Show("Bite whlen Sie einen Dienst aus", "", MessageBoxButtons.OK); comboDienst.Select(); return; }
            if (comboPrs.Text == "") { MessageBox.Show("Bite whlen Sie eine Person aus", "", MessageBoxButtons.OK); comboPrs.Select(); return; }
            if (comboAbteilung.SelectedIndex < 0) { MessageBox.Show("Bite whlen Sie eine Abteilung aus", "", MessageBoxButtons.OK); comboAbteilung.Select(); return; }

			DienstData.SaveDienstSerie(comboPrs.SelectedPrsID, comboDienst.SelectedDienstID, comboAbteilung.SelectedAbteilungID, int.Parse(txtTag.Text), typ, dateVon.Text, dateBis.Text);

            resetGui();
        }

        private void update()
        {
            if (typ == "M" && Convert.ToInt32(txtTag.Text) > 30) { MessageBox.Show("Tag hat keine gltige Zahl", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            if (typ == "W" && Convert.ToInt32(txtTag.Text) > 7) { MessageBox.Show("Tag hat keine gltige Zahl", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            
			if (txtTag.Text == "") { MessageBox.Show("Bite geben Sie einen Tag ein", "", MessageBoxButtons.OK); txtTag.Select(); return; }
            if (comboDienst.Text == "") { MessageBox.Show("Bite whlen Sie einen Dienst aus", "", MessageBoxButtons.OK); comboDienst.Select(); return; }
            if (comboPrs.Text == "") { MessageBox.Show("Bite whlen Sie eine Person aus", "", MessageBoxButtons.OK); comboPrs.Select(); return; }
            if (comboAbteilung.SelectedIndex < 0) { MessageBox.Show("Bite whlen Sie eine Abteilung aus", "", MessageBoxButtons.OK); comboAbteilung.Select(); return; }

			DienstData.UpdateDienstSerie(comboPrs.SelectedPrsID, comboDienst.SelectedDienstID, comboAbteilung.SelectedAbteilungID, int.Parse(txtTag.Text), typ, dateVon.Text, dateBis.Text,
				old_prsid, old_abteilungid, old_dienstid, old_tag, old_von, old_bis, old_typ);

            resetGui();
        }

        private void handleKeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar > 31 && (e.KeyChar < '0' || e.KeyChar > '9'))
            {
                e.Handled = true;
            }
        }

        private void setComboTyp()
        {
            if (comboTyp.Items.Count > 0)
                comboTyp.Items.Clear();

            comboTyp.Items.Add("Jede Woche");
            comboTyp.Items.Add("Jeden Monat");

            comboTyp.SelectedIndex = 0;

            setTyp();
        }

        private void setTyp()
        {
            switch (comboTyp.Text)
            {
                case "Jede Woche":
                    typ = "W";
                    break;
                case "Jeden Monat":
                    typ = "M";
                    break;
            }
        }

        private string getDayOrMonth(string art)
        {
            string wm = "";
            switch (art)
            {
                case "W":
                    wm = "Jede Woche";
                    break;
                case "M":
                    wm = "Jenden Monat";
                    break;
            }
            return wm;
        }

        private int getDayOrMonthIndex(string art)
        {
            int index = 0;

            switch (art)
            {
                case "W":
                    index = 0;
                    break;
                case "M":
                    index = 1;
                    break;
            }

            return index;
        }

        private void comboTyp_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedIndex >= 0)
				changed = true;

            setTyp();
        }

        private void comboDienst_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedIndex >= 0)
				changed = true;
        }

        private void comboPrs_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedIndex >= 0)
				changed = true;
        }

        private void txtTag_TextChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedIndex >= 0)
				changed = true;
        }

        private void comboDienstSerie_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedDienstID >= 0)
			{
				old_prsid = comboDienstSerie.SelectedPrsID;
				old_abteilungid = comboDienstSerie.SelectedAbteilungID;
				old_dienstid = comboDienstSerie.SelectedDienstID;
				old_tag = comboDienstSerie.SelectedTag;
				old_von = comboDienstSerie.SelectedVon;
				old_bis = comboDienstSerie.SelectedBis;
				old_typ = comboDienstSerie.SelectedTyp;

				comboDienst.SetIndexAt(comboDienstSerie.SelectedDienstID);
				comboPrs.SetIndexAt(comboDienstSerie.SelectedPrsID);
				comboAbteilung.SetIndexAt(comboDienstSerie.SelectedAbteilungID);
				txtTag.Text = comboDienstSerie.SelectedTag.ToString();

				comboTyp.SelectedIndex = getDayOrMonthIndex(comboDienstSerie.SelectedTyp);
				dateVon.Text = comboDienstSerie.SelectedVon;
				dateBis.Text = comboDienstSerie.SelectedBis;
			}
			else
				resetGui();

            // Am Schluss
            changed = false;
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            resetGui();
        }

        private void comboAbteilung_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboDienstSerie.SelectedIndex >= 0)
			{
				changed = true;
			}
        }

        private void dateVon_ValueChanged(object sender, EventArgs e)
        {
            if (comboDienstSerie.SelectedIndex >= 0)
                changed = true;
        }

        private void dateBis_ValueChanged(object sender, EventArgs e)
        {
            if (comboDienstSerie.SelectedIndex >= 0)
                changed = true;
        }

        private void resetGui()
        {
            comboDienst.SelectedIndex = -1;
            comboDienstSerie.SelectedIndex = -1;
            comboPrs.SelectedIndex = -1;
            comboAbteilung.Text = ""; // List is empty...
            comboTyp.SelectedIndex = 0;
            txtTag.Text = "";
            dateVon.Value = DateTime.Today;
            dateBis.Value = DateTime.Today;

            changed = false;
        }
    }
}