using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.PrsUtil.Controls;
using Gencode.PrsCommon.Data.Person;

namespace Personalplaner
{
    [ToolboxItem(false)]
	public partial class MainFerien : UserControl, Gencode.Gengui.Forms.IDeleteNewSaveDialog//Form
    {
		DataView m_ferien;

        public MainFerien()
        {
            InitializeComponent();

			comboPrs.InitData(Verwaltung.Mandant);
        }

        private void comboPrs_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetGrid();
        }

        private void SetGrid()
        {
            if (comboPrs.SelectedIndex >= 0)
            {
				m_ferien = PersonData.GetFerien(comboPrs.SelectedPrsID, Verwaltung.Year);
				gridFerien.AutoGenerateColumns = false;
				gridFerien.DataSource = m_ferien;

				gridFerien.Columns["von"].DataPropertyName = "von";
				gridFerien.Columns["bis"].DataPropertyName = "bis";
            }
        }

        private string formatDate(string date)
        {
            return String.Format("{0}{1}{2}{3}{4}{5}{6}{7}{8}{9}", date[0], date[1], date[2], date[3], date[4], date[5], date[6], date[7], date[8], date[9]);
		}


		#region IDeleteNewSaveDialog Members

		public void NewClicked()
		{
			Personalplaner.ZeitDlg.Datetimeformat timeFormat = Personalplaner.ZeitDlg.Datetimeformat.ShortDate;
			Personalplaner.ZeitDlg.Datetype dateSort = Personalplaner.ZeitDlg.Datetype.Ferien;
			if (comboPrs.Text == "")
			{
				MessageBox.Show("Bitte eine Person auswhlen", "", MessageBoxButtons.OK);
				comboPrs.Focus();
			}
			else
			{
				Form dlgZeit = new ZeitDlg(timeFormat, dateSort, comboPrs.SelectedPrsID);
				dlgZeit.ShowDialog();

				// grid abfllen
				SetGrid();
			}
		}

		public void SaveClicked()
		{
		}

		public bool OKClicked()
		{
			return true;
		}

		public bool CancleClicked()
		{
			return true;
		}

		public void DeleteClicked()
		{
			if (comboPrs.SelectedPrsID > 0 &&
				gridFerien.SelectedRows.Count > 0)
			{
				PersonData.DeleteFerien(int.Parse(m_ferien[gridFerien.SelectedRows[0].Index].Row["FerienID"].ToString()));
				SetGrid();
			}
		}

		#endregion
	}
}