using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.PrsCommon.Data.Person;
using Gencode.PrsCommon.Data.Plan;

namespace Personalplaner
{
    [ToolboxItem(false)]
	public partial class SaldoAnpassenDlg : UserControl, Gencode.Gengui.Forms.IDeleteNewSaveDialog
    {
		DataView m_personen;
        DataView m_anpassungen;
		private int PlanID
		{
			get;
			set;
		}

        public SaldoAnpassenDlg(int planid)
        {
            InitializeComponent();

			PlanID = planid;

			int schemaid = PlanData.GetPlanSchemaID(PlanID);
			m_personen = PlanData.GetPersonenInSchema(schemaid);

			GridPersonen.AutoGenerateColumns = false;
			GridPersonen.DataSource = m_personen;
        }


        //private bool checkHours()
        //{
        //    bool check = true;

        //    if (txtStd.Text.Length > 7)
        //        check = false;

        //    int i = txtStd.Text.IndexOf(".");
        //    int l = txtStd.Text.Length;

        //    if (i > -1)
        //    {
        //        if (l - (i + 1) > 2)
        //        {
        //            check = false;
        //        }
        //    }
        //    return check;
        //}

        private void SetSaldoGrid()
        {
			m_anpassungen = PlanData.GetSaldoAnpassung(int.Parse(m_personen[GridPersonen.SelectedCells[0].RowIndex].Row["prsid"].ToString()),
				int.Parse(m_personen[GridPersonen.SelectedCells[0].RowIndex].Row["abteilungid"].ToString()),
				PlanID);

			GridAnpassung.AutoGenerateColumns = false;
			GridAnpassung.DataSource = m_anpassungen;

			GridAnpassung.Columns["datum"].DataPropertyName = "datum";
			GridAnpassung.Columns["zeit"].DataPropertyName = "stunden";
			GridAnpassung.Columns["grund"].DataPropertyName = "grund";
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
			//if (listSaldo.SelectedIndex >= 0)
			//{
			//    if (MessageBox.Show(listSaldo.SelectedItem.ToString() + " Lschen?", "Eintrag Lschen?", MessageBoxButtons.YesNo) == DialogResult.Yes)
			//    {
			//        int tmpID = comboPrs.SelectedIndex;
			//        int prsid = plan[comboPrs.SelectedIndex].PrsID;
			//        int planid = plan[comboPrs.SelectedIndex].PlanID;
			//        int saldoid = plan[comboPrs.SelectedIndex].SaldoElement[listSaldo.SelectedIndex].SaldoID;

			//        DBConection.Execute("delete from saldoanpassung where prsid = " + prsid + " and planid = " + planid + " and saldoid = " + saldoid);

			//        txtGrund.Text = "";
			//        txtStd.Text = "";
			//        listSaldo.Items.Clear();

			//        Data.ArbeitsPlan.ArbeitsPlanData[plan[comboPrs.SelectedIndex].PlanIndex].PersonPlanData[plan[comboPrs.SelectedIndex].PrsIndex].SetPersonSaldoAnpassen();
			//        plan[comboPrs.SelectedIndex].ResetSaldoElements();
			//        comboPrs.SelectedIndex = tmpID;
			//    }
			//}
        }

		#region IDialogControl Members

		public void DeleteClicked()
		{
            if (GridAnpassung.Rows.Count > 0 && GridAnpassung.SelectedCells[0].RowIndex >= 0)
            {
                if (MessageBox.Show("Sind Sie sicher dass Sie den Eintrag Lschen mchten?", "Eintrag Lschen?", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    PlanData.DeleteSaldoAnpassung(int.Parse(m_anpassungen[GridAnpassung.SelectedCells[0].RowIndex].Row["saldoid"].ToString()));
                    
                    txtGrund.Text = "";
                    txtStd.Text = "";
                    SetSaldoGrid();
                }
            }
		}

		public void NewClicked()
		{
			txtGrund.Text = "";
			txtStd.Text = "";
		}

		public void SaveClicked()
		{
			if (txtGrund.Text != string.Empty &&
				txtGrund.Text != string.Empty)
			{
				double stunden = 0;
				bool error = false;
				try
				{
					stunden = double.Parse(txtStd.Text);
				}
				catch(InvalidCastException e) 
				{
					Gencode.Common.Util.ErrorHandler.ShowError("Fehler beim Umwandeln des Zahlenwertes " + txtStd.Text + "\nBitte geben Sie eine Zahl ein.", "Keine Zahl vorhanden");
					Gencode.Common.Util.ErrorHandler.LoggError("Personalplaner", e);
					error = true;
				}

				if (!error)
				{
					PlanData.SetSaldoAnpassung(int.Parse(m_personen[GridPersonen.SelectedCells[0].RowIndex].Row["prsid"].ToString()),
						int.Parse(m_personen[GridPersonen.SelectedCells[0].RowIndex].Row["abteilungid"].ToString()),
						PlanID, dateDatum.Text, txtGrund.Text, stunden);

					txtGrund.Text = "";
					txtStd.Text = "";
					SetSaldoGrid();
				}
			}
		}

		public bool OKClicked()
		{
			//do nothing
			return true;
		}

		public bool CancleClicked()
		{
			//do nothing
			return true;
		}

		#endregion

		private void SaldoAnpassenDlg_Load(object sender, EventArgs e)
		{
			//[prsID,name,nachname,abteilungid,abteilungname,prsschemaid,rgb]
			GridPersonen.Columns["prsid"].DataPropertyName = "prsid";
			GridPersonen.Columns["vorname"].DataPropertyName = "name";
			GridPersonen.Columns["nachname"].DataPropertyName = "nachname";
			GridPersonen.Columns["abteilung"].DataPropertyName = "abteilungname";
		}

		private void GridPersonen_CellClick(object sender, DataGridViewCellEventArgs e)
		{
			SetSaldoGrid();
		}
	}
}