using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.Common.SQL;

namespace Personalplaner
{
    public partial class TerminNewDlg : Form
    {
        string rdoCheck = "H";
        string farbeName = "";
        int argb = 0;
        bool checkColor = false;

        Color colWhite;
        Color colBlack;

        public TerminNewDlg()
        {
            InitializeComponent();
            colWhite = Color.FromName("white");
            colBlack = Color.FromName("black");
        }

        private void setColor()
        {
            if (farbeName != "" && argb != 0)
            {
                Color newCol = Color.FromName(farbeName);
                newCol = Color.FromArgb(argb);
                if (rdoCheck == "H")
                {
                    txtColor.BackColor = newCol;
                    txtColor.ForeColor = colBlack;
                }
                else if (rdoCheck == "S")
                {
                    txtColor.ForeColor = newCol;
                    txtColor.BackColor = colWhite;
                }

                checkColor = true;
            }
        }

        private bool save()
        {
            if (txtName.Text == ""){MessageBox.Show("Bitte geben Sie einen Namen ein","",MessageBoxButtons.OK); return false;}
            if (txtKurzText.Text == "") { MessageBox.Show("Bitte geben Sie einen Kurztext ein", "", MessageBoxButtons.OK); return false; }
            if (txtBeschr.Text == "") { MessageBox.Show("Bitte geben Sie eine Beschreibung ein", "", MessageBoxButtons.OK); return false; }
            if (!checkColor) { MessageBox.Show("Termine werden im Plan farblich dargestellt.\nBitte whlen Sie eine Farbe aus.", "", MessageBoxButtons.OK); return false; }

			Querry stp = new Querry();

            stp.SetSTPName("set_termin");

            stp.AddParameter("@terminname", txtName.Text);
            stp.AddParameter("@kurztext", txtKurzText.Text);
            stp.AddParameter("@beschreibung ", txtBeschr.Text);
            stp.AddParameter("@rgbin", argb);
            stp.AddParameter("@colorname", farbeName);
            stp.AddParameter("@shgin", rdoCheck);
            stp.AddParameter("@mandid", Verwaltung.Mandant);

            stp.Execute();

            return true;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (save() != false)
            {
                this.Close();
            }
        }

        private void btnColour_Click(object sender, EventArgs e)
        {
            ColorDialog color = new ColorDialog();
            if (color.ShowDialog() == DialogResult.OK)
            {
                farbeName = color.Color.Name;
                argb = color.Color.ToArgb();

                setColor();
            }
        }

        private void rdoBackColour_CheckedChanged(object sender, EventArgs e)
        {
            rdoCheck = "H";
            setColor();
        }

        private void rdoTxtColour_CheckedChanged(object sender, EventArgs e)
        {
            rdoCheck = "S";
            setColor();
        }
    }
}