using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Personalplaner
{
    public partial class ZeitDlg : Form
    {
		public enum Datetimeformat { ShortDate, Time };
		public enum Timetype { Pause, Dienstzeit };
		public enum Datetype { Ferien };

        //BEGIN TEST
        Datetimeformat timeSelect;
        Timetype timeSort;
        Datetype dateSort;
        //END TEST

        private int ID;
        //private int dienstID;
        private int prsID;

        public ZeitDlg()
        {
            InitializeComponent();
        }

        public ZeitDlg(Datetimeformat timeSelect, Datetype dateSort, int prsId)
        {
            InitializeComponent();

            this.timeSelect = timeSelect;
            this.dateSort = dateSort;
            this.prsID = prsId;

            //InitializeDateTimePicker();
            switch (this.timeSelect)
            {
                //case SetZeit.TimeDateFormat.ShortDate:
                case Datetimeformat.ShortDate: // TEST
                    timeVon.Format = DateTimePickerFormat.Short;
                    timeBis.Format = DateTimePickerFormat.Short;
                    break;
                //case SetZeit.TimeDateFormat.Time:
                case Datetimeformat.Time: // TEST
                    timeVon.Format = DateTimePickerFormat.Time;
                    timeBis.Format = DateTimePickerFormat.Time;
                    break;
            }

			lblTyp.Visible = false;
			comboType.Visible = false;
        }

        public ZeitDlg(Datetimeformat timeSelect, int dienstID)
        {
            InitializeComponent();

            this.timeSelect = timeSelect;
			//this.timeSort = timeSort;
            this.ID = dienstID;

            //InitializeDateTimePicker();
            switch (this.timeSelect)
            {
                //case SetZeit.TimeDateFormat.ShortDate:
                case Datetimeformat.ShortDate:
                    timeVon.Format = DateTimePickerFormat.Short;
                    timeBis.Format = DateTimePickerFormat.Short;
                    break;
                //case SetZeit.TimeDateFormat.Time:
                case Datetimeformat.Time:
                    timeVon.Format = DateTimePickerFormat.Time;
                    timeBis.Format = DateTimePickerFormat.Time;
                    break;
            }

			comboType.Items.Add(Timetype.Pause.ToString());
			comboType.Items.Add(Timetype.Dienstzeit.ToString());
        }

        private void InitializeDateTimePicker()
        {
            switch (this.timeSelect)
            {
                //case SetZeit.TimeDateFormat.ShortDate:
                case Datetimeformat.ShortDate:
                    timeVon.Format = DateTimePickerFormat.Short;
                    timeBis.Format = DateTimePickerFormat.Short;
                    break;
                //case SetZeit.TimeDateFormat.Time:
                case Datetimeformat.Time:
                    timeVon.Format = DateTimePickerFormat.Time;
                    timeBis.Format = DateTimePickerFormat.Time;
                    break;
            }
        }
        private void btnCancle_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
			if(timeVon.Value > timeBis.Value)
            //if (Convert.ToInt32(formatDate(timeVon.Value.ToString())) > Convert.ToInt32(formatDate(timeBis.Value.ToString())))
            {
                MessageBox.Show("Zeit von ist grsser als Zeit bis...", "", MessageBoxButtons.OK);
                return;
            }
            else
            {
                SetZeit stZt = new SetZeit();
                switch (timeSelect)
                {
                    case Datetimeformat.Time:
                        if (timeSort == Timetype.Pause)
                        {
							//SetZeit.SetDienstZeit("set_zeit", ID, timeVon.Text, timeBis.Text, "P",); // P = Pause
                        }
                        else if (timeSort == Timetype.Dienstzeit)
                        {
							//SetZeit.SetDienstZeit("set_zeit", ID, timeVon.Text, timeBis.Text, "Z"); // Z = Dienstzeit
                        }
                        break;
                    case (Datetimeformat.ShortDate):
                        if (dateSort == Datetype.Ferien)
                        {
                            SetZeit.SetFerienZeit("set_ferienzeit", this.prsID, timeVon.Text.ToString(), timeBis.Text.ToString());
                        }
                        break;
                    default:
                        break;
                }
                this.Close();
            }
        }

        private string formatDate(string date)
        {
            if (this.timeSelect == Datetimeformat.ShortDate)
            {
                // bei Datum
                return String.Format("{0}{1}{2}{3}{4}{5}{6}{7}", date[6], date[7], date[8], date[9], date[3], date[4], date[0], date[1]);
            }
            else
            {
                // bei Zeit
                return String.Format("{0}{1}{2}{3}{4}{5}", date[0], date[1], date[3], date[4], date[6], date[7]);
            }

        }

		private void comboType_SelectedIndexChanged(object sender, EventArgs e)
		{
			timeSort = (Timetype)comboType.SelectedIndex;
		}
    }
}