using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.PrsCommon.Data.Abteilung;

namespace Personalplaner
{
    [ToolboxItem(false)]
	public partial class newAbteilung : UserControl, Gencode.Gengui.Forms.IDeleteNewSaveDialog//Form
    {
        public newAbteilung()
        {
            InitializeComponent();

			comboAbteilung.InitData(Verwaltung.Mandant);
        }

        private void comboAbteilung_SelectedIndexChanged(object sender, EventArgs e)
        {
			txtName.Text = comboAbteilung.SelectedAbteilungName;
			txtBeschr.Text = comboAbteilung.SelectedAbteilungBeschreibung;
			txtStdPTag.Text = comboAbteilung.SelectedAbteilungStunden;
        }

		#region IDeleteNewSaveDialog Members

		public void DeleteClicked()
		{
			if (comboAbteilung.Text != "")
			{
				if (!AbteilungData.CheckIfAbteilungIsUsed(comboAbteilung.SelectedAbteilungID))
				{
					if (MessageBox.Show("Sind Sie sicher dass Sie die Abteilung:\n" + comboAbteilung.Text + "\nlschen mchten?", "Abteilung lschen?", MessageBoxButtons.OKCancel) == DialogResult.OK)
					{
						AbteilungData.DeleteAbteilung(comboAbteilung.SelectedAbteilungID);

						comboAbteilung.RefreshData();
						
						txtName.Text = "";
						txtBeschr.Text = "";
					}
				}
				else
					MessageBox.Show("Die Abteilung kann nicht gelscht werden da diese bereits in einem Plan verwendet wird.", "", MessageBoxButtons.OK);
			}
		}

		#endregion

		#region ISaveNewDialog Members

		public void NewClicked()
		{
			comboAbteilung.SelectedIndex = 0;
		}

		#endregion

		#region ISaveDialog Members

		public void SaveClicked()
		{
			if (txtName.Text == string.Empty || txtBeschr.Text == string.Empty || txtStdPTag.Text == string.Empty || txtStdPTag.Text == "0")
			{
				MessageBox.Show("Bitte fllen Sie alle Felder aus.", "", MessageBoxButtons.OK);
				return;
			}

			//Update
			if(comboAbteilung.SelectedAbteilungID > 0)
			{
				double tmp = 0;
				try
				{
					tmp = double.Parse(txtStdPTag.Text);
				}
				catch { }

				AbteilungData.UpdateAbteilung(comboAbteilung.SelectedAbteilungID, txtName.Text, txtBeschr.Text, tmp);
			}
			else
			{
				double tmp = 0;
				try
				{
					tmp = double.Parse(txtStdPTag.Text);
				}
				catch { }
				AbteilungData.SaveNewAbteilung(txtName.Text,txtBeschr.Text,tmp,Verwaltung.Mandant);
			}

			comboAbteilung.RefreshData();
		}

		#endregion

		#region IDialogControl Members

		public bool OKClicked()
		{
			return true;
		}

		public bool CancleClicked()
		{
			return true;
		}

		#endregion
	}
}