using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Personalplaner.Options
{
    public partial class OptionsDlg : Form
    {
        OptionsDisplay optDisplay = new OptionsDisplay();
        OptionsArbeitsZeitData optArbeitsZeitData = new OptionsArbeitsZeitData();
		PersonDisplay personDisplay = new PersonDisplay();
		AblaufOptions ablauf = new AblaufOptions();

        List<IOptionsInterface> options = new List<IOptionsInterface>();

        public OptionsDlg()
        {
            InitializeComponent();
            addTabControlls();
            setInterface();
        }

        private void btnCancle_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (checkIfChanged())
            {
                if (MessageBox.Show("Es wurden nderungen vorgenommen.\nMchten sie diese Speichern?", "nderungen Speichern", 
                    MessageBoxButtons.YesNo,MessageBoxIcon.None,MessageBoxDefaultButton.Button1,MessageBoxOptions.RightAlign) == DialogResult.Yes)
                {
                    saveOptions();
                }
            }
            this.Close();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            saveOptions();

            //Optionen neu auslesen
            PlanOption.SetData();
        }

        private void addTabControlls()
        {
            // Displayoptionen
            tabCtrl.TabPages[0].Controls.Add(optDisplay);
            optDisplay.Dock = DockStyle.Fill;
            tabCtrl.TabPages[0].Text = "Anzeige";

			//Ablufe
			tabCtrl.TabPages[1].Controls.Add(ablauf);
			ablauf.Dock = DockStyle.Fill;
			tabCtrl.TabPages[1].Text = "Ablufe";

            //Arbeitszeitoptionen
            tabCtrl.TabPages[2].Controls.Add(optArbeitsZeitData);
            optArbeitsZeitData.Dock = DockStyle.Fill;
            tabCtrl.TabPages[2].Text = "Arbeitszeiten";

			tabCtrl.TabPages[3].Controls.Add(personDisplay);
			personDisplay.Dock = DockStyle.Fill;
			tabCtrl.TabPages[3].Text = "Person bersicht";
        }

        private void setInterface()
        {
            options.Add(optDisplay);
			options.Add(ablauf);
            options.Add(optArbeitsZeitData);
			options.Add(personDisplay);
        }

        private void saveOptions()
        {
            options.ForEach(delegate(IOptionsInterface op)
            {
                op.save();
            });
        }

        private bool checkIfChanged()
        {
            bool changed = false;

            options.ForEach(delegate(IOptionsInterface op)
            { if (op.checkIfChanged() == true)changed = true; });

            return changed;
        }
    }
}