using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Gencode.Gengui.Display;

namespace Personalplaner.Modules.Personoverview
{
    [ToolboxItem(false)]
	public partial class ContentPerson : DisplayableViewControler
    {
		///
		/// Indicates if the current view is being utilized in the VS.NET IDE or not.
		///
		public new bool DesignMode
		{
			get
			{
				return (System.Diagnostics.Process.GetCurrentProcess().ProcessName == "devenv");
			}
		}

		OverviewBaseView PartnerContent
		{
			get
			{
				return PartnerView as OverviewBaseView;
			}
		}

        public ContentPerson(/*PersonOverviewMain mainPerson*/)
        {
            InitializeComponent();
			//this.PartnerContent = mainPerson;
			//this.Height = 309;

			if (!this.DesignMode)
			{
				comboPerson.InitData(Verwaltung.Mandant);
			}
        }
        
        public void SetComboPersonIndex(int prsid)
        {
			comboPerson.SetIndexAt(prsid);
        }

        private void comboPerson_SelectedIndexChanged(object sender, EventArgs e)
        {
			if (comboPerson.SelectedPrsID > 0)
			{
				PartnerContent.ChangePerson(comboPerson.SelectedPrsID, comboPerson.Text);
				overviewSelector1.Enabled = true;
			}
			else
				overviewSelector1.Enabled = false;
        }

		private void overviewSelector1_DiversClick(object sender, EventArgs e)
		{
			if (comboPerson.SelectedPrsID > 0)
			{
				PartnerContent.SetView(DETAILANZEIGE.Monatsbersicht);
			}
		}

		private void overviewSelector1_HolidayClick(object sender, EventArgs e)
		{
			if (comboPerson.SelectedPrsID > 0)
			{
				PartnerContent.SetView(DETAILANZEIGE.Ferien);
			}
		}

		private void overviewSelector1_JahresplanClick(object sender, EventArgs e)
		{
			if (comboPerson.SelectedPrsID > 0)
			{
				PartnerContent.SetView(DETAILANZEIGE.Jahresplan);
			}
		}

		private void ContentPerson_Load(object sender, EventArgs e)
		{
			if (comboPerson.SelectedPrsID > 0)
				overviewSelector1.Enabled = true;
			else
				overviewSelector1.Enabled = false;

		}

		public override int CalculateHeight(int maxHeight)
		{
			//309
			return 309;// this.Height;
		}
    }
}
