﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.Gengui.Wizzard;
using Gencode.PrsCommon.Data.Abteilung;

namespace Gencode.PrsUtil.InitWizard
{
    [ToolboxItem(false)]
	public partial class InitAbteilung : Gencode.Gengui.Wizzard.WizzardControl
	{
		public InitAbteilung(string previousControl, string nextControl, WizzardDialog controler)
			: base(previousControl, nextControl, controler)
		{
			InitializeComponent();
		}

		private void btnAdd_Click(object sender, EventArgs e)
		{
			if (txtName.Text != string.Empty)
			{
				double tmp = 0;
				try
				{
					tmp = double.Parse(txtStdPTag.Text);
				}
				catch { }

				InitData da = Controler.DataObjects.GetType(typeof(InitData)) as InitData;
				AbteilungData.SaveNewAbteilung(txtName.Text, txtBeschr.Text, tmp, da.Mandid);

				InitializeListBox(da.Mandid);

				txtBeschr.Text = "";
				txtName.Text = "";
				txtStdPTag.Text = "0";
			}
		}

		private void InitializeListBox(string mandid)
		{
			DataView dv = Gencode.Common.SQL.SimpleQuerry.ExecuteForDataView("select Name from Abteilung where mandid = '" + mandid + "'");
			listAbt.DataSource = dv;
			listAbt.DisplayMember = "Name";
		}

		public override bool MoveNext()
		{
			if (listAbt.Items.Count > 0)
			{
				return true;
			}

			MessageBox.Show("Es muss mindestens 1 Abteilung erstellt werden.", "Abteilung erstellen", MessageBoxButtons.OK);
			return false;
		}
	}
}
