﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.Gengui.Wizzard;

namespace Gencode.PrsUtil.InitWizard
{
    [ToolboxItem(false)]
	public partial class InitAnstellung : Gencode.Gengui.Wizzard.WizzardControl
	{
		public InitAnstellung(string previousControl, string nextControl, WizzardDialog controler)
			: base(previousControl, nextControl, controler)
		{
			InitializeComponent();
		}

		private void btnAdd_Click(object sender, EventArgs e)
		{
			if (txtName.Text == "")
			{
				MessageBox.Show("Es ist kein Name vorhanden...", "", MessageBoxButtons.OK);
				return;
			}

			InitData da = Controler.DataObjects.GetType(typeof(InitData)) as InitData;
			Gencode.PrsCommon.Data.Anstellung.AnstellungData.SaveNewAnstellung(txtName.Text, txtBeschr.Text, 0,
				int.Parse(numEinsPTag.Value.ToString()), checkRechnen.Checked, da.Mandid, checkAusgelernt.Checked);

			txtName.Text = "";
			txtBeschr.Text = "";

			InitializeListBox(da.Mandid);
		}

		private void InitializeListBox(string mandid)
		{
			DataView dv = Gencode.Common.SQL.SimpleQuerry.ExecuteForDataView("select Name from Anstellung where mandid = '" + mandid + "'");
			listAbt.DataSource = dv;
			listAbt.DisplayMember = "Name";
		}

		public override bool MoveNext()
		{
			if (listAbt.Items.Count > 0)
			{
				return true;
			}

			MessageBox.Show("Es muss mindestens 1 Anstellung erstellt werden.", "Abteilung erstellen", MessageBoxButtons.OK);
			return false;
		}
	}
}
