﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gencode.Gengui.Wizzard;

namespace Gencode.PrsUtil.InitWizard
{
    [ToolboxItem(false)]
	public partial class InitPerson : Gencode.Gengui.Wizzard.WizzardControl
	{
		string mandid;
		public InitPerson(string previousControl, string nextControl, WizzardDialog controler)
			: base(previousControl, nextControl, controler)
		{
			InitializeComponent();
		}

		public override void InitializeWizzardControl()
		{
			InitData da = Controler.DataObjects.GetType(typeof(InitData)) as InitData;
			if (da != null)
			{
				mandid = da.Mandid;
				GridPersonen.InitData(da.Mandid, Gencode.PrsCommon.Data.Person.PersonTyp.Stammperson);
				Gencode.Common.ActionLogger.Logger.LoggMessage(Gencode.Common.ActionLogger.MessageType.DATA_EVENT, "Initialisation of users in InitWizard");
			}
			else
			{
				Gencode.Common.ActionLogger.Logger.LoggMessage(Gencode.Common.ActionLogger.MessageType.DATA_EVENT, "Error while initializing. No Mandant");
				Gencode.Common.Util.ErrorHandler.LoggError("no mandant", "Gencode.PrsUtil.InitWizard.InitPerson.InitializeWizzardControl()",
					"Beim einlesen der Mandanten ist ein Fehler aufgetreten.\nDie Applikation wird beendet.");
				Gencode.Common.Util.ErrorHandler.ShowError("Beim einlesen der Mandanten ist ein Fehler aufgetreten.\nDie Applikation wird beendet.", "Fehler");
			}
		}

		private void btnAdd_Click(object sender, EventArgs e)
		{
			if (GridPersonen.Rows.Count > 0)
			{
				GridPersonen[0, 0].Selected = true;
				GridPersonen[0, 0].Selected = false;
			}

			if (string.IsNullOrEmpty(mandid))
			{
				InitData da = Controler.DataObjects.GetType(typeof(InitData)) as InitData;
				mandid = da.Mandid;
			}

			Form dialog = new Gencode.PrsUtil.Dialog.Stammdaten.PersonWizard.AddPersonWizard(mandid);
			dialog.ShowDialog(this);

			GridPersonen.ReloadData();
		}
	}
}
